//line php5/php5.y:2
package php5

import __yyfmt__ "fmt"

//line php5/php5.y:2
import (
	//    "fmt"
	//    "strings"
	"strconv"

	"github.com/z7zmey/php-parser/node"
	"github.com/z7zmey/php-parser/node/expr"
	"github.com/z7zmey/php-parser/node/expr/assign_op"
	"github.com/z7zmey/php-parser/node/name"
	"github.com/z7zmey/php-parser/node/scalar"
	"github.com/z7zmey/php-parser/node/stmt"
	"github.com/z7zmey/php-parser/token"

//    "github.com/z7zmey/php-parser/node/expr/binary_op"
//    "github.com/z7zmey/php-parser/node/expr/cast"
)

//line php5/php5.y:22
type yySymType struct {
	yys   int
	node  node.Node
	token token.Token
	//    boolWithToken boolWithToken
	list                    []node.Node
	foreachVariable         foreachVariable
	nodesWithEndToken       *nodesWithEndToken
	simpleIndirectReference simpleIndirectReference
	objectPropertyList      []objectProperty
	//    str string
}

const T_INCLUDE = 57346
const T_INCLUDE_ONCE = 57347
const T_EXIT = 57348
const T_IF = 57349
const T_LNUMBER = 57350
const T_DNUMBER = 57351
const T_STRING = 57352
const T_STRING_VARNAME = 57353
const T_VARIABLE = 57354
const T_NUM_STRING = 57355
const T_INLINE_HTML = 57356
const T_CHARACTER = 57357
const T_BAD_CHARACTER = 57358
const T_ENCAPSED_AND_WHITESPACE = 57359
const T_CONSTANT_ENCAPSED_STRING = 57360
const T_ECHO = 57361
const T_DO = 57362
const T_WHILE = 57363
const T_ENDWHILE = 57364
const T_FOR = 57365
const T_ENDFOR = 57366
const T_FOREACH = 57367
const T_ENDFOREACH = 57368
const T_DECLARE = 57369
const T_ENDDECLARE = 57370
const T_AS = 57371
const T_SWITCH = 57372
const T_ENDSWITCH = 57373
const T_CASE = 57374
const T_DEFAULT = 57375
const T_BREAK = 57376
const T_CONTINUE = 57377
const T_GOTO = 57378
const T_FUNCTION = 57379
const T_CONST = 57380
const T_RETURN = 57381
const T_TRY = 57382
const T_CATCH = 57383
const T_FINALLY = 57384
const T_THROW = 57385
const T_USE = 57386
const T_INSTEADOF = 57387
const T_GLOBAL = 57388
const T_VAR = 57389
const T_UNSET = 57390
const T_ISSET = 57391
const T_EMPTY = 57392
const T_HALT_COMPILER = 57393
const T_CLASS = 57394
const T_TRAIT = 57395
const T_INTERFACE = 57396
const T_EXTENDS = 57397
const T_IMPLEMENTS = 57398
const T_OBJECT_OPERATOR = 57399
const T_DOUBLE_ARROW = 57400
const T_LIST = 57401
const T_ARRAY = 57402
const T_CALLABLE = 57403
const T_CLASS_C = 57404
const T_TRAIT_C = 57405
const T_METHOD_C = 57406
const T_FUNC_C = 57407
const T_LINE = 57408
const T_FILE = 57409
const T_COMMENT = 57410
const T_DOC_COMMENT = 57411
const T_OPEN_TAG = 57412
const T_OPEN_TAG_WITH_ECHO = 57413
const T_CLOSE_TAG = 57414
const T_WHITESPACE = 57415
const T_START_HEREDOC = 57416
const T_END_HEREDOC = 57417
const T_DOLLAR_OPEN_CURLY_BRACES = 57418
const T_CURLY_OPEN = 57419
const T_PAAMAYIM_NEKUDOTAYIM = 57420
const T_NAMESPACE = 57421
const T_NS_C = 57422
const T_DIR = 57423
const T_NS_SEPARATOR = 57424
const T_ELLIPSIS = 57425
const T_EVAL = 57426
const T_REQUIRE = 57427
const T_REQUIRE_ONCE = 57428
const T_LOGICAL_OR = 57429
const T_LOGICAL_XOR = 57430
const T_LOGICAL_AND = 57431
const T_INSTANCEOF = 57432
const T_NEW = 57433
const T_CLONE = 57434
const T_ELSEIF = 57435
const T_ELSE = 57436
const T_ENDIF = 57437
const T_PRINT = 57438
const T_YIELD = 57439
const T_STATIC = 57440
const T_ABSTRACT = 57441
const T_FINAL = 57442
const T_PRIVATE = 57443
const T_PROTECTED = 57444
const T_PUBLIC = 57445
const T_INC = 57446
const T_DEC = 57447
const T_YIELD_FROM = 57448
const T_INT_CAST = 57449
const T_DOUBLE_CAST = 57450
const T_STRING_CAST = 57451
const T_ARRAY_CAST = 57452
const T_OBJECT_CAST = 57453
const T_BOOL_CAST = 57454
const T_UNSET_CAST = 57455
const T_COALESCE = 57456
const T_SPACESHIP = 57457
const T_NOELSE = 57458
const T_PLUS_EQUAL = 57459
const T_MINUS_EQUAL = 57460
const T_MUL_EQUAL = 57461
const T_DIV_EQUAL = 57462
const T_CONCAT_EQUAL = 57463
const T_MOD_EQUAL = 57464
const T_AND_EQUAL = 57465
const T_OR_EQUAL = 57466
const T_XOR_EQUAL = 57467
const T_SL_EQUAL = 57468
const T_SR_EQUAL = 57469
const T_POW_EQUAL = 57470
const T_BOOLEAN_OR = 57471
const T_BOOLEAN_AND = 57472
const T_IS_EQUAL = 57473
const T_IS_NOT_EQUAL = 57474
const T_IS_IDENTICAL = 57475
const T_IS_NOT_IDENTICAL = 57476
const T_IS_SMALLER_OR_EQUAL = 57477
const T_IS_GREATER_OR_EQUAL = 57478
const T_SL = 57479
const T_SR = 57480
const T_POW = 57481

var yyToknames = [...]string{
	"$end",
	"error",
	"$unk",
	"T_INCLUDE",
	"T_INCLUDE_ONCE",
	"T_EXIT",
	"T_IF",
	"T_LNUMBER",
	"T_DNUMBER",
	"T_STRING",
	"T_STRING_VARNAME",
	"T_VARIABLE",
	"T_NUM_STRING",
	"T_INLINE_HTML",
	"T_CHARACTER",
	"T_BAD_CHARACTER",
	"T_ENCAPSED_AND_WHITESPACE",
	"T_CONSTANT_ENCAPSED_STRING",
	"T_ECHO",
	"T_DO",
	"T_WHILE",
	"T_ENDWHILE",
	"T_FOR",
	"T_ENDFOR",
	"T_FOREACH",
	"T_ENDFOREACH",
	"T_DECLARE",
	"T_ENDDECLARE",
	"T_AS",
	"T_SWITCH",
	"T_ENDSWITCH",
	"T_CASE",
	"T_DEFAULT",
	"T_BREAK",
	"T_CONTINUE",
	"T_GOTO",
	"T_FUNCTION",
	"T_CONST",
	"T_RETURN",
	"T_TRY",
	"T_CATCH",
	"T_FINALLY",
	"T_THROW",
	"T_USE",
	"T_INSTEADOF",
	"T_GLOBAL",
	"T_VAR",
	"T_UNSET",
	"T_ISSET",
	"T_EMPTY",
	"T_HALT_COMPILER",
	"T_CLASS",
	"T_TRAIT",
	"T_INTERFACE",
	"T_EXTENDS",
	"T_IMPLEMENTS",
	"T_OBJECT_OPERATOR",
	"T_DOUBLE_ARROW",
	"T_LIST",
	"T_ARRAY",
	"T_CALLABLE",
	"T_CLASS_C",
	"T_TRAIT_C",
	"T_METHOD_C",
	"T_FUNC_C",
	"T_LINE",
	"T_FILE",
	"T_COMMENT",
	"T_DOC_COMMENT",
	"T_OPEN_TAG",
	"T_OPEN_TAG_WITH_ECHO",
	"T_CLOSE_TAG",
	"T_WHITESPACE",
	"T_START_HEREDOC",
	"T_END_HEREDOC",
	"T_DOLLAR_OPEN_CURLY_BRACES",
	"T_CURLY_OPEN",
	"T_PAAMAYIM_NEKUDOTAYIM",
	"T_NAMESPACE",
	"T_NS_C",
	"T_DIR",
	"T_NS_SEPARATOR",
	"T_ELLIPSIS",
	"T_EVAL",
	"T_REQUIRE",
	"T_REQUIRE_ONCE",
	"T_LOGICAL_OR",
	"T_LOGICAL_XOR",
	"T_LOGICAL_AND",
	"T_INSTANCEOF",
	"T_NEW",
	"T_CLONE",
	"T_ELSEIF",
	"T_ELSE",
	"T_ENDIF",
	"T_PRINT",
	"T_YIELD",
	"T_STATIC",
	"T_ABSTRACT",
	"T_FINAL",
	"T_PRIVATE",
	"T_PROTECTED",
	"T_PUBLIC",
	"T_INC",
	"T_DEC",
	"T_YIELD_FROM",
	"T_INT_CAST",
	"T_DOUBLE_CAST",
	"T_STRING_CAST",
	"T_ARRAY_CAST",
	"T_OBJECT_CAST",
	"T_BOOL_CAST",
	"T_UNSET_CAST",
	"T_COALESCE",
	"T_SPACESHIP",
	"T_NOELSE",
	"'\"'",
	"'`'",
	"'{'",
	"'}'",
	"';'",
	"':'",
	"'('",
	"')'",
	"'['",
	"']'",
	"'?'",
	"'&'",
	"'-'",
	"'+'",
	"'!'",
	"'~'",
	"'@'",
	"'$'",
	"','",
	"'='",
	"T_PLUS_EQUAL",
	"T_MINUS_EQUAL",
	"T_MUL_EQUAL",
	"T_DIV_EQUAL",
	"T_CONCAT_EQUAL",
	"T_MOD_EQUAL",
	"T_AND_EQUAL",
	"T_OR_EQUAL",
	"T_XOR_EQUAL",
	"T_SL_EQUAL",
	"T_SR_EQUAL",
	"T_POW_EQUAL",
	"T_BOOLEAN_OR",
	"T_BOOLEAN_AND",
	"'|'",
	"'^'",
	"T_IS_EQUAL",
	"T_IS_NOT_EQUAL",
	"T_IS_IDENTICAL",
	"T_IS_NOT_IDENTICAL",
	"'<'",
	"T_IS_SMALLER_OR_EQUAL",
	"'>'",
	"T_IS_GREATER_OR_EQUAL",
	"T_SL",
	"T_SR",
	"'.'",
	"'*'",
	"'/'",
	"'%'",
	"T_POW",
}
var yyStatenames = [...]string{}

const yyEofCode = 1
const yyErrCode = 2
const yyInitialStackSize = 16

//line php5/php5.y:2074

//line yacctab:1
var yyExca = [...]int{
	-1, 1,
	1, -1,
	-2, 0,
	-1, 50,
	104, 477,
	105, 477,
	-2, 475,
	-1, 101,
	78, 374,
	-2, 453,
	-1, 113,
	78, 495,
	123, 491,
	-2, 501,
	-1, 153,
	104, 477,
	105, 477,
	-2, 475,
	-1, 203,
	121, 348,
	124, 348,
	-2, 472,
	-1, 204,
	104, 477,
	105, 477,
	121, 349,
	124, 349,
	-2, 475,
	-1, 270,
	78, 495,
	-2, 501,
	-1, 297,
	78, 376,
	-2, 455,
	-1, 301,
	123, 492,
	-2, 502,
	-1, 310,
	78, 375,
	-2, 454,
	-1, 372,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 309,
	-1, 373,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 310,
	-1, 374,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 311,
	-1, 375,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 312,
	-1, 376,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 313,
	-1, 377,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 314,
	-1, 378,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 315,
	-1, 379,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 316,
	-1, 386,
	104, 477,
	105, 477,
	-2, 475,
	-1, 437,
	123, 486,
	-2, 490,
	-1, 455,
	104, 477,
	105, 477,
	124, 558,
	135, 558,
	-2, 475,
	-1, 456,
	124, 559,
	135, 559,
	-2, 472,
	-1, 457,
	104, 477,
	105, 477,
	-2, 475,
	-1, 479,
	124, 181,
	135, 181,
	-2, 472,
	-1, 480,
	104, 477,
	105, 477,
	124, 182,
	135, 182,
	-2, 475,
	-1, 486,
	123, 516,
	-2, 560,
	-1, 492,
	123, 516,
	-2, 561,
	-1, 514,
	78, 374,
	-2, 411,
	-1, 560,
	124, 167,
	-2, 172,
	-1, 568,
	121, 350,
	124, 350,
	-2, 472,
	-1, 569,
	104, 477,
	105, 477,
	121, 351,
	124, 351,
	-2, 475,
	-1, 576,
	57, 259,
	125, 259,
	-2, 258,
	-1, 662,
	78, 376,
	-2, 413,
	-1, 689,
	124, 167,
	-2, 172,
	-1, 704,
	124, 167,
	-2, 172,
	-1, 760,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 439,
	-1, 761,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 440,
	-1, 762,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 441,
	-1, 763,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 442,
	-1, 764,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 443,
	-1, 765,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 444,
	-1, 766,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 445,
	-1, 767,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 446,
	-1, 770,
	78, 375,
	-2, 412,
	-1, 821,
	57, 254,
	-2, 256,
	-1, 879,
	37, 228,
	-2, 225,
	-1, 940,
	123, 486,
	-2, 490,
	-1, 1002,
	29, 216,
	-2, 4,
	-1, 1028,
	124, 167,
	-2, 172,
	-1, 1032,
	121, 220,
	-2, 222,
}

const yyPrivate = 57344

const yyLast = 8356

var yyAct = [...]int{

	101, 1053, 705, 996, 587, 883, 822, 915, 199, 122,
	130, 850, 824, 815, 425, 867, 470, 707, 327, 445,
	437, 4, 717, 412, 510, 113, 335, 467, 694, 795,
	136, 664, 454, 413, 384, 318, 683, 314, 440, 329,
	97, 114, 6, 157, 263, 129, 60, 328, 478, 25,
	5, 178, 2, 288, 191, 227, 227, 634, 634, 191,
	1027, 636, 635, 42, 137, 968, 990, 967, 142, 987,
	989, 964, 959, 983, 930, 918, 863, 720, 819, 701,
	266, 966, 257, 988, 984, 43, 573, 146, 931, 573,
	38, 699, 688, 644, 645, 646, 637, 639, 640, 638,
	638, 509, 700, 297, 352, 270, 613, 324, 1038, 634,
	152, 816, 240, 636, 635, 161, 810, 614, 250, 599,
	269, 271, 634, 774, 503, 310, 572, 203, 315, 319,
	600, 178, 322, 177, 179, 180, 178, 573, 504, 499,
	301, 656, 658, 657, 659, 644, 645, 646, 637, 639,
	640, 638, 536, 500, 711, 340, 552, 353, 468, 334,
	227, 637, 639, 640, 638, 120, 117, 553, 120, 634,
	351, 354, 642, 636, 635, 200, 309, 349, 168, 170,
	169, 191, 443, 158, 120, 492, 333, 120, 240, 191,
	969, 350, 266, 939, 227, 641, 643, 654, 655, 652,
	653, 656, 658, 657, 659, 644, 645, 646, 637, 639,
	640, 638, 852, 851, 899, 898, 1008, 270, 192, 172,
	176, 175, 227, 346, 38, 344, 830, 389, 176, 175,
	417, 957, 269, 271, 825, 161, 380, 772, 725, 345,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 311,
	620, 227, 174, 177, 179, 180, 178, 295, 427, 449,
	132, 300, 612, 312, 486, 103, 120, 299, 943, 892,
	387, 611, 1061, 605, 133, 604, 578, 119, 441, 577,
	302, 444, 227, 466, 444, 460, 973, 451, 729, 240,
	1042, 464, 823, 728, 442, 159, 119, 472, 473, 119,
	585, 293, 592, 130, 488, 292, 487, 502, 591, 433,
	286, 506, 280, 253, 441, 514, 252, 1007, 4, 441,
	230, 230, 1009, 975, 866, 861, 858, 484, 429, 430,
	442, 465, 490, 945, 856, 442, 477, 958, 839, 6,
	531, 191, 809, 514, 294, 264, 674, 5, 498, 456,
	458, 495, 615, 606, 430, 429, 429, 125, 430, 120,
	602, 125, 422, 120, 634, 420, 306, 544, 636, 635,
	1057, 1028, 479, 444, 125, 304, 120, 432, 138, 540,
	176, 175, 926, 296, 807, 296, 563, 38, 119, 798,
	227, 704, 654, 655, 652, 653, 656, 658, 657, 659,
	644, 645, 646, 637, 639, 640, 638, 575, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 439,
	852, 851, 382, 697, 689, 230, 228, 663, 574, 229,
	228, 560, 530, 229, 441, 441, 634, 388, 571, 596,
	636, 635, 287, 228, 277, 232, 229, 484, 490, 232,
	442, 442, 274, 538, 273, 485, 539, 264, 593, 230,
	491, 597, 232, 441, 294, 249, 441, 38, 441, 221,
	347, 194, 227, 568, 646, 637, 639, 640, 638, 442,
	193, 119, 442, 141, 442, 119, 121, 230, 616, 787,
	788, 315, 696, 332, 1048, 319, 1047, 1044, 119, 134,
	514, 308, 1017, 307, 4, 787, 788, 662, 191, 514,
	1016, 1006, 972, 951, 913, 909, 514, 514, 514, 514,
	514, 446, 854, 848, 633, 6, 230, 847, 626, 779,
	629, 692, 686, 5, 684, 535, 125, 494, 120, 1014,
	562, 391, 678, 342, 227, 227, 227, 176, 175, 155,
	897, 563, 586, 676, 1063, 483, 715, 230, 563, 1035,
	949, 925, 266, 924, 227, 227, 685, 922, 497, 812,
	716, 305, 196, 38, 698, 485, 491, 853, 693, 181,
	182, 174, 177, 179, 180, 178, 428, 270, 722, 871,
	524, 223, 224, 786, 907, 908, 731, 721, 125, 227,
	120, 227, 269, 271, 595, 228, 719, 439, 229, 598,
	843, 844, 125, 631, 294, 737, 125, 738, 524, 125,
	628, 125, 90, 735, 232, 514, 514, 514, 514, 514,
	514, 514, 514, 514, 514, 514, 514, 514, 514, 514,
	514, 514, 514, 514, 514, 514, 514, 514, 514, 514,
	514, 514, 770, 739, 514, 125, 508, 505, 256, 258,
	119, 501, 709, 710, 431, 230, 294, 267, 714, 661,
	268, 448, 125, 294, 120, 483, 456, 416, 321, 514,
	563, 564, 793, 773, 565, 771, 232, 227, 124, 125,
	479, 320, 514, 316, 124, 563, 1020, 808, 784, 1002,
	782, 125, 668, 792, 563, 814, 462, 811, 801, 294,
	294, 789, 718, 791, 294, 258, 804, 783, 799, 452,
	431, 415, 119, 259, 260, 123, 813, 131, 127, 128,
	827, 294, 447, 828, 829, 887, 888, 889, 886, 885,
	884, 228, 618, 619, 229, 258, 419, 230, 622, 623,
	281, 285, 418, 303, 38, 298, 667, 796, 564, 514,
	232, 565, 825, 833, 461, 514, 514, 258, 564, 450,
	258, 565, 283, 131, 262, 524, 713, 567, 463, 259,
	260, 258, 395, 207, 524, 1018, 431, 227, 206, 227,
	868, 524, 524, 524, 524, 524, 119, 1054, 61, 258,
	703, 563, 806, 44, 282, 776, 1019, 563, 462, 259,
	260, 555, 860, 53, 284, 859, 872, 258, 869, 230,
	230, 230, 255, 862, 534, 894, 227, 891, 895, 514,
	284, 259, 260, 497, 259, 260, 896, 264, 1060, 230,
	230, 441, 901, 1026, 900, 259, 260, 777, 730, 441,
	1010, 911, 162, 905, 514, 985, 563, 442, 718, 919,
	38, 238, 914, 259, 260, 442, 1039, 916, 225, 233,
	916, 980, 1033, 563, 230, 933, 230, 44, 921, 961,
	904, 259, 260, 927, 554, 855, 787, 788, 542, 991,
	938, 790, 787, 788, 514, 962, 580, 937, 582, 581,
	524, 524, 524, 524, 524, 524, 524, 524, 524, 524,
	524, 524, 524, 524, 524, 524, 524, 524, 524, 524,
	524, 524, 524, 524, 524, 524, 524, 946, 934, 524,
	125, 963, 803, 948, 741, 970, 740, 632, 950, 630,
	38, 894, 627, 952, 944, 954, 955, 512, 583, 557,
	514, 971, 507, 474, 524, 514, 932, 563, 392, 563,
	323, 890, 230, 202, 201, 198, 974, 524, 976, 135,
	977, 590, 588, 589, 986, 512, 940, 727, 665, 992,
	514, 514, 439, 521, 956, 543, 563, 393, 254, 1015,
	439, 208, 209, 210, 211, 213, 214, 215, 216, 217,
	218, 219, 220, 212, 1011, 1012, 75, 74, 251, 563,
	923, 248, 551, 1023, 794, 1032, 881, 381, 514, 563,
	576, 1037, 882, 358, 1021, 880, 38, 936, 38, 563,
	38, 357, 38, 38, 524, 356, 355, 817, 724, 723,
	524, 524, 1036, 893, 1056, 1034, 820, 821, 563, 682,
	336, 879, 38, 1031, 38, 38, 1041, 1000, 1029, 999,
	998, 997, 230, 995, 230, 994, 965, 935, 1046, 1050,
	1013, 878, 877, 601, 876, 446, 887, 888, 889, 886,
	885, 884, 960, 929, 1064, 208, 209, 210, 211, 213,
	214, 215, 216, 217, 218, 219, 220, 212, 928, 38,
	875, 230, 874, 476, 524, 708, 706, 1003, 942, 912,
	947, 993, 38, 1001, 566, 881, 396, 40, 712, 38,
	561, 882, 394, 39, 880, 559, 870, 14, 38, 524,
	13, 1062, 512, 1059, 1052, 864, 1051, 1049, 1025, 116,
	1001, 512, 38, 903, 953, 865, 805, 702, 512, 512,
	512, 512, 512, 800, 556, 195, 383, 163, 537, 338,
	1022, 1004, 910, 1030, 681, 680, 140, 677, 533, 524,
	139, 906, 649, 647, 648, 887, 888, 889, 886, 885,
	884, 845, 781, 1043, 532, 842, 780, 675, 331, 10,
	1, 832, 734, 438, 231, 231, 289, 873, 453, 160,
	156, 317, 1058, 313, 126, 115, 265, 63, 88, 579,
	634, 89, 660, 642, 636, 635, 513, 100, 73, 272,
	11, 325, 99, 98, 78, 524, 118, 519, 511, 3,
	524, 0, 0, 0, 651, 650, 641, 643, 654, 655,
	652, 653, 656, 658, 657, 659, 644, 645, 646, 637,
	639, 640, 638, 0, 0, 524, 524, 512, 512, 512,
	512, 512, 512, 512, 512, 512, 512, 512, 512, 512,
	512, 512, 512, 512, 512, 512, 512, 512, 512, 512,
	512, 512, 512, 512, 0, 0, 512, 0, 0, 0,
	0, 0, 0, 524, 0, 0, 0, 0, 0, 231,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	634, 512, 660, 642, 636, 635, 0, 0, 0, 0,
	0, 0, 0, 0, 512, 0, 0, 0, 0, 0,
	0, 272, 0, 231, 651, 650, 641, 643, 654, 655,
	652, 653, 656, 658, 657, 659, 644, 645, 646, 637,
	639, 640, 638, 0, 0, 0, 0, 0, 0, 0,
	0, 231, 208, 209, 210, 211, 213, 214, 215, 216,
	217, 218, 219, 220, 212, 0, 0, 0, 0, 30,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 512, 0, 0, 0, 0, 0, 512, 512, 0,
	231, 0, 144, 150, 154, 0, 0, 0, 164, 0,
	0, 0, 0, 0, 0, 0, 197, 0, 0, 0,
	0, 205, 0, 0, 0, 0, 0, 168, 170, 169,
	191, 231, 222, 0, 0, 0, 234, 235, 236, 237,
	0, 0, 239, 0, 241, 242, 243, 244, 245, 246,
	247, 0, 0, 0, 0, 0, 0, 261, 0, 0,
	831, 512, 275, 276, 0, 278, 279, 192, 172, 176,
	175, 0, 0, 0, 0, 0, 290, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 512, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 239, 0,
	0, 337, 0, 0, 0, 0, 512, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 231,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	359, 360, 361, 362, 363, 364, 365, 366, 367, 368,
	369, 370, 371, 372, 373, 374, 375, 376, 377, 378,
	379, 0, 0, 0, 154, 0, 0, 0, 0, 0,
	0, 0, 512, 0, 0, 0, 0, 512, 398, 400,
	401, 402, 403, 404, 405, 406, 407, 408, 409, 410,
	411, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 512, 512, 0, 0, 0, 0, 0, 0,
	0, 231, 0, 0, 0, 0, 0, 0, 0, 239,
	0, 424, 426, 426, 0, 0, 50, 0, 0, 434,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	512, 0, 0, 154, 154, 0, 0, 459, 0, 0,
	426, 153, 0, 0, 0, 0, 426, 290, 0, 0,
	0, 0, 426, 426, 0, 0, 154, 0, 204, 426,
	489, 343, 0, 0, 0, 493, 0, 0, 0, 0,
	0, 226, 226, 231, 231, 231, 208, 209, 210, 211,
	213, 214, 215, 216, 217, 218, 219, 220, 212, 0,
	0, 272, 0, 231, 231, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 541, 0, 0,
	0, 0, 0, 0, 545, 546, 547, 548, 549, 0,
	649, 647, 648, 0, 0, 0, 0, 666, 231, 0,
	231, 0, 0, 0, 669, 670, 671, 672, 673, 0,
	0, 550, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 838, 0, 154, 634, 0,
	660, 642, 636, 635, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 348, 0, 0, 0,
	0, 0, 651, 650, 641, 643, 654, 655, 652, 653,
	656, 658, 657, 659, 644, 645, 646, 637, 639, 640,
	638, 0, 0, 0, 594, 0, 0, 0, 0, 0,
	385, 386, 0, 0, 0, 0, 231, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 607, 609,
	0, 0, 0, 0, 0, 0, 0, 0, 414, 0,
	0, 0, 617, 742, 743, 744, 745, 746, 747, 748,
	749, 750, 751, 752, 753, 754, 755, 756, 757, 758,
	759, 760, 761, 762, 763, 764, 765, 766, 767, 769,
	0, 0, 666, 0, 0, 0, 0, 436, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	455, 457, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 634, 0, 0, 642, 636, 635, 471, 0,
	0, 691, 0, 480, 0, 0, 231, 0, 231, 0,
	0, 0, 0, 649, 647, 648, 651, 650, 641, 643,
	654, 655, 652, 653, 656, 658, 657, 659, 644, 645,
	646, 637, 639, 640, 638, 726, 0, 0, 0, 0,
	0, 426, 732, 0, 0, 231, 0, 0, 0, 0,
	154, 634, 836, 660, 642, 636, 635, 0, 0, 0,
	0, 0, 0, 0, 154, 0, 0, 837, 0, 0,
	0, 0, 0, 840, 841, 651, 650, 641, 643, 654,
	655, 652, 653, 656, 658, 657, 659, 644, 645, 646,
	637, 639, 640, 638, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 569, 0, 570, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	634, 0, 0, 642, 636, 635, 0, 0, 0, 0,
	0, 337, 785, 0, 0, 0, 0, 902, 0, 0,
	0, 168, 170, 169, 191, 650, 641, 643, 654, 655,
	652, 653, 656, 658, 657, 659, 644, 645, 646, 637,
	639, 640, 638, 0, 0, 0, 0, 0, 0, 0,
	818, 0, 0, 0, 0, 0, 0, 0, 426, 426,
	826, 192, 172, 176, 175, 0, 834, 0, 471, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 941, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 0, 0, 0, 0, 649, 647, 648, 0,
	0, 0, 0, 0, 0, 0, 0, 849, 0, 0,
	0, 0, 0, 0, 857, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	385, 695, 695, 778, 634, 0, 660, 642, 636, 635,
	0, 0, 0, 426, 0, 0, 0, 0, 0, 0,
	414, 414, 0, 0, 0, 0, 0, 0, 651, 650,
	641, 643, 654, 655, 652, 653, 656, 658, 657, 659,
	644, 645, 646, 637, 639, 640, 638, 455, 0, 0,
	0, 0, 0, 0, 0, 471, 0, 471, 0, 0,
	0, 480, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 426, 0, 0, 94, 28, 19, 18, 0,
	20, 0, 32, 0, 33, 0, 0, 21, 0, 0,
	337, 22, 23, 37, 44, 15, 24, 35, 0, 0,
	36, 9, 0, 26, 0, 31, 80, 81, 7, 45,
	47, 49, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 797, 0, 0, 8, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 46, 48, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 625, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 0, 20, 0, 32, 0, 33,
	0, 0, 21, 695, 0, 414, 22, 23, 37, 44,
	15, 24, 35, 0, 0, 36, 9, 0, 26, 0,
	31, 80, 81, 7, 45, 47, 49, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 471, 0, 0, 0, 92, 0, 0, 0,
	0, 8, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 46, 48, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 16, 496, 34, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	17, 104, 105, 12, 87, 120, 0, 29, 0, 0,
	0, 94, 28, 19, 18, 0, 20, 0, 32, 0,
	33, 0, 0, 21, 0, 0, 0, 22, 23, 37,
	44, 15, 24, 35, 0, 0, 36, 9, 0, 26,
	0, 31, 80, 81, 7, 45, 47, 49, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 8, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	41, 27, 46, 48, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 16, 0, 34, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 17, 104, 105, 12, 87, 120, 0, 29, 0,
	0, 0, 94, 28, 19, 18, 0, 20, 0, 32,
	0, 33, 0, 0, 21, 0, 0, 0, 22, 23,
	37, 44, 0, 24, 35, 0, 0, 36, 0, 0,
	26, 0, 31, 80, 81, 330, 45, 47, 49, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 41, 27, 46, 48, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 16, 1065, 34, 0, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 0,
	32, 0, 33, 0, 0, 21, 0, 0, 0, 22,
	23, 37, 44, 0, 24, 35, 0, 0, 36, 0,
	0, 26, 0, 31, 80, 81, 330, 45, 47, 49,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 46, 48, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 1055, 34, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 0, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 0, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 0, 24, 35, 0, 0, 36,
	0, 0, 26, 0, 31, 80, 81, 330, 45, 47,
	49, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 46, 48, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 1045, 34, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 0,
	20, 1040, 32, 0, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 0, 24, 35, 0, 0,
	36, 0, 0, 26, 0, 31, 80, 81, 330, 45,
	47, 49, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 46, 48, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 0, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 17, 104, 105, 12, 87,
	120, 0, 29, 0, 0, 0, 94, 28, 19, 18,
	0, 20, 0, 32, 0, 33, 0, 0, 21, 0,
	0, 0, 22, 23, 37, 44, 0, 24, 35, 0,
	0, 36, 0, 0, 26, 0, 31, 80, 81, 330,
	45, 47, 49, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 27, 46, 48, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 16, 1005, 34,
	0, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 0, 20, 0, 32, 0, 33, 0, 0, 21,
	0, 0, 0, 22, 23, 37, 44, 0, 24, 35,
	0, 0, 36, 0, 0, 26, 0, 31, 80, 81,
	330, 45, 47, 49, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 46, 48,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 982,
	34, 0, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 0, 24,
	35, 0, 0, 36, 0, 0, 26, 0, 31, 80,
	81, 330, 45, 47, 49, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 46,
	48, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	981, 34, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 17, 104,
	105, 12, 87, 120, 0, 29, 0, 0, 0, 94,
	28, 19, 18, 0, 20, 0, 32, 0, 33, 0,
	0, 21, 0, 0, 0, 22, 23, 37, 44, 0,
	24, 35, 0, 0, 36, 0, 0, 26, 0, 31,
	80, 81, 330, 45, 47, 49, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 27,
	46, 48, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	16, 979, 34, 0, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 0, 20, 0, 32, 978, 33,
	0, 0, 21, 0, 0, 0, 22, 23, 37, 44,
	0, 24, 35, 0, 0, 36, 0, 0, 26, 0,
	31, 80, 81, 330, 45, 47, 49, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 46, 48, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 16, 0, 34, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	17, 104, 105, 12, 87, 120, 0, 29, 0, 0,
	0, 94, 28, 19, 18, 0, 20, 0, 32, 0,
	33, 920, 0, 21, 0, 0, 0, 22, 23, 37,
	44, 0, 24, 35, 0, 0, 36, 0, 0, 26,
	0, 31, 80, 81, 330, 45, 47, 49, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	41, 27, 46, 48, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 16, 0, 34, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 17, 104, 105, 12, 87, 120, 0, 29, 0,
	0, 0, 94, 28, 19, 18, 846, 20, 0, 32,
	0, 33, 0, 0, 21, 0, 0, 0, 22, 23,
	37, 44, 0, 24, 35, 0, 0, 36, 0, 0,
	26, 0, 31, 80, 81, 330, 45, 47, 49, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 41, 27, 46, 48, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 16, 0, 34, 0, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 0,
	32, 0, 33, 0, 0, 21, 0, 0, 0, 22,
	23, 37, 44, 0, 24, 35, 0, 0, 36, 0,
	0, 26, 0, 31, 80, 81, 330, 45, 47, 49,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 46, 48, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 558, 34, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 0, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 0, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 0, 24, 35, 0, 0, 36,
	0, 0, 26, 0, 31, 80, 81, 330, 45, 47,
	49, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 46, 48, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 326, 34, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 0,
	20, 0, 32, 0, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 0, 24, 35, 0, 0,
	36, 0, 0, 26, 0, 31, 80, 81, 330, 45,
	47, 49, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 46, 48, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 0, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 17, 104, 105, 12, 87,
	120, 0, 29, 0, 0, 0, 94, 28, 19, 18,
	0, 20, 0, 32, 0, 33, 0, 0, 21, 0,
	0, 0, 22, 23, 37, 44, 0, 24, 35, 0,
	0, 36, 0, 0, 26, 0, 31, 80, 81, 0,
	0, 0, 0, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 27, 0, 0, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 16, 0, 34,
	1024, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 0, 20, 0, 32, 0, 33, 0, 0, 21,
	0, 0, 0, 22, 23, 37, 44, 0, 24, 35,
	0, 0, 36, 0, 0, 26, 0, 31, 80, 81,
	0, 0, 0, 0, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 0, 0,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 0,
	34, 917, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 0, 24,
	35, 0, 0, 36, 0, 0, 26, 0, 31, 80,
	81, 0, 0, 0, 0, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 0,
	0, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	0, 34, 802, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 17, 104,
	105, 12, 87, 120, 0, 29, 0, 0, 0, 94,
	28, 19, 18, 0, 20, 0, 32, 0, 33, 0,
	0, 21, 0, 0, 0, 22, 23, 37, 44, 0,
	24, 35, 0, 0, 36, 0, 0, 26, 0, 31,
	80, 81, 0, 0, 0, 0, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 27,
	0, 0, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	16, 0, 34, 679, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 0, 20, 0, 32, 0, 33,
	0, 0, 21, 0, 0, 0, 22, 23, 37, 44,
	0, 24, 35, 0, 0, 36, 0, 0, 26, 0,
	31, 80, 81, 0, 0, 0, 0, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 775, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 649, 647, 648, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 736, 0, 0, 91,
	76, 16, 0, 34, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 0, 0, 634,
	0, 660, 642, 636, 635, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 651, 650, 641, 643, 654, 655, 652,
	653, 656, 658, 657, 659, 644, 645, 646, 637, 639,
	640, 638, 0, 0, 0, 192, 172, 176, 175, 0,
	0, 0, 0, 168, 170, 169, 191, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 733, 0, 0, 0,
	0, 0, 0, 192, 172, 176, 175, 0, 0, 168,
	170, 169, 191, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 166, 167, 171, 173, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 690, 0, 0, 0, 0, 192,
	172, 176, 175, 0, 0, 0, 0, 168, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 166, 167, 171, 173, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	687, 0, 0, 0, 0, 0, 0, 192, 172, 176,
	175, 0, 0, 0, 0, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 624, 0,
	0, 0, 0, 0, 0, 192, 172, 176, 175, 0,
	0, 0, 0, 168, 170, 169, 191, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 621, 0, 0, 0,
	0, 0, 0, 192, 172, 176, 175, 168, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 166, 167, 171, 173, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 603, 0, 0, 192, 172, 176,
	175, 0, 0, 0, 0, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 584, 0,
	0, 0, 0, 0, 0, 192, 172, 176, 175, 0,
	0, 0, 0, 0, 0, 0, 0, 469, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 168, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 192, 172, 176, 175,
	168, 170, 169, 191, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 397, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 421, 0, 0,
	192, 172, 176, 175, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 166, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 0, 0, 0, 192, 172, 176, 175, 0, 0,
	0, 168, 170, 169, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 390, 0, 0, 0, 0,
	0, 192, 172, 176, 175, 0, 0, 0, 168, 170,
	169, 191, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 341, 0, 0, 0, 0, 0, 192, 172,
	176, 175, 0, 0, 0, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 339,
	0, 0, 0, 0, 0, 192, 172, 176, 175, 0,
	0, 0, 168, 170, 169, 191, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 165, 0, 0, 0,
	0, 0, 192, 172, 176, 175, 649, 647, 648, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 166, 167, 171, 173, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 0, 634, 0, 660, 642, 636, 635,
	168, 170, 169, 191, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 651, 650,
	641, 643, 654, 655, 652, 653, 656, 658, 657, 659,
	644, 645, 646, 637, 639, 640, 638, 0, 0, 0,
	192, 172, 176, 175, 647, 648, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 166, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 634, 0, 660, 642, 636, 635, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 651, 650, 641, 643, 654,
	655, 652, 653, 656, 658, 657, 659, 644, 645, 646,
	637, 639, 640, 638, 0, 0, 192, 172, 176, 175,
	0, 648, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 634, 0, 660,
	642, 636, 635, 169, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 651, 650, 641, 643, 654, 655, 652, 653, 656,
	658, 657, 659, 644, 645, 646, 637, 639, 640, 638,
	0, 192, 172, 176, 175, 191, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 192, 172, 176, 175, 191, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 166, 167, 171, 173, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 0, 172, 176, 175, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 166, 167, 171, 173, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 0, 172, 176, 175, 0, 0,
	0, 0, 82, 83, 71, 0, 104, 105, 125, 87,
	120, 0, 0, 0, 0, 0, 94, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 44, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 80, 81, 0,
	0, 0, 0, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 482, 84, 85, 86, 191, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 147, 0, 0, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 0, 0, 0,
	0, 62, 475, 96, 176, 175, 481, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 0, 104, 105, 125,
	87, 120, 0, 0, 0, 0, 0, 94, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 0, 0, 0, 44, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 80, 81,
	0, 0, 0, 0, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 191, 0, 0, 148, 112,
	108, 102, 482, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 145, 147, 0, 0,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 172, 176, 175, 91, 76, 0, 0,
	0, 0, 62, 0, 96, 0, 0, 481, 57, 56,
	58, 59, 72, 119, 0, 0, 171, 173, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 634, 0, 0, 642, 636, 635, 0,
	0, 0, 0, 82, 83, 71, 0, 104, 105, 125,
	87, 120, 0, 0, 0, 0, 0, 94, 0, 0,
	643, 654, 655, 652, 653, 656, 658, 657, 659, 644,
	645, 646, 637, 639, 640, 638, 44, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 80, 81,
	0, 0, 0, 0, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 145, 147, 0, 0,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 0, 0,
	0, 0, 62, 0, 96, 0, 0, 835, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 0, 104, 105,
	125, 87, 120, 0, 0, 0, 0, 0, 94, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 44, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 80,
	81, 0, 0, 0, 0, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 145, 147, 0,
	0, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 0,
	0, 0, 0, 62, 0, 96, 0, 0, 610, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 0, 104,
	105, 125, 87, 120, 0, 0, 0, 0, 0, 94,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 44, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	80, 81, 0, 0, 0, 0, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 191, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 145, 147,
	0, 0, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 172, 176, 175, 91, 76,
	0, 0, 0, 0, 62, 0, 96, 0, 0, 608,
	57, 56, 58, 59, 72, 119, 0, 0, 0, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 82, 83, 71, 0, 104,
	105, 125, 87, 120, 0, 0, 0, 0, 0, 94,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 44, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	80, 81, 0, 0, 0, 0, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 145, 147,
	0, 0, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	0, 0, 0, 0, 62, 0, 96, 0, 0, 291,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 0,
	104, 105, 125, 87, 120, 0, 0, 0, 0, 0,
	94, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 44,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 80, 81, 0, 0, 0, 0, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	191, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	147, 0, 0, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 0, 0, 0, 0, 62, 423, 96, 172, 176,
	175, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	0, 104, 105, 125, 87, 120, 0, 0, 0, 0,
	0, 94, 0, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 0, 0,
	44, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	145, 147, 0, 0, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 0, 0, 0, 0, 62, 0, 96, 0,
	0, 399, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 0, 104, 105, 125, 87, 120, 0, 0, 0,
	0, 0, 94, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 44, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 80, 81, 0, 0, 0, 0, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 145, 147, 0, 0, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 0, 0, 151, 0, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 0, 104, 105, 125, 87, 120, 0, 0,
	0, 0, 0, 94, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 44, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 80, 81, 0, 0, 0, 0,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 145, 147, 0, 0, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 0, 0, 149, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 0, 104, 105, 125, 87, 120, 0,
	0, 0, 0, 0, 94, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 44, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 80, 81, 0, 0, 0,
	0, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 145, 147, 0, 0, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 0, 0, 143, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 0, 104, 105, 125, 87, 120,
	0, 0, 0, 0, 0, 94, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 44, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 80, 81, 0, 0,
	0, 0, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 145, 147, 0, 0, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 634, 91, 76, 642, 636, 635, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 654, 655, 652, 653, 656, 658, 657, 659, 644,
	645, 646, 637, 639, 640, 638, 82, 83, 71, 0,
	104, 105, 125, 435, 120, 0, 0, 0, 0, 0,
	94, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 44,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 80, 81, 0, 0, 0, 0, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 145,
	147, 0, 0, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 0, 0, 0, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	0, 104, 105, 125, 87, 120, 0, 0, 0, 0,
	0, 94, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	44, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 104, 105, 125, 77,
	41, 147, 0, 0, 0, 0, 522, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 0, 0, 0, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 517, 0,
	520, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 523, 0, 0, 0, 0, 515, 112, 108,
	516, 104, 105, 125, 0, 0, 0, 0, 0, 0,
	0, 522, 0, 0, 0, 0, 232, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	768, 529, 0, 518, 0, 0, 0, 528, 527, 525,
	526, 0, 0, 517, 0, 520, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 523, 0, 0,
	0, 0, 515, 112, 108, 516, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 232, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 529, 0, 518, 0,
	0, 0, 528, 527, 525, 526,
}
var yyPact = [...]int{

	-1000, -1000, 2543, -1000, -1000, -1000, -1000, 373, 616, 701,
	149, -1000, 387, -1000, -1000, 969, -1000, 265, -1000, -1000,
	370, 265, 7646, 7515, 7384, 438, 171, 850, 7777, -1000,
	5775, 367, 358, -1000, -1000, 463, 7777, 965, 47, 964,
	963, 7777, -1000, -1000, -1000, -1000, 746, -1000, 741, -1000,
	1236, 356, 7777, 497, 536, 536, 7777, 7777, 7777, 7777,
	-1000, -1000, 8063, -1000, 7777, 7777, 7777, 7777, 7777, 7777,
	7777, 352, -1000, -1000, 201, 198, 815, 7777, 727, 598,
	341, 339, 7777, 7777, 331, 7777, 7777, -1000, 197, -1000,
	-1000, 797, 765, -1000, 195, 329, 6991, -1000, 190, 186,
	-1000, 272, 930, 687, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, 152, 156, -1000, 685, 270, -1000, 462,
	-1000, 252, 392, -1000, 930, -1000, 138, 621, 619, -1000,
	659, 930, -1000, 960, -1000, -29, 4246, 381, 8063, 265,
	5032, 7777, -1000, -1000, 5728, -1000, 47, 776, 622, -1000,
	5681, -1000, 432, 1570, 5863, -1000, 104, -1000, -1000, 361,
	56, 47, -32, 36, 5863, -1000, -1000, -1000, -1000, -1000,
	7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777,
	7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777,
	7777, 598, 310, 536, 7777, 324, -1000, 5634, 430, 958,
	-1000, 737, -1000, -1000, 1236, 5587, -1000, -1000, 7253, 7777,
	7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777, 7777,
	7777, 672, -1000, -1000, -1000, -1000, -1000, 272, 605, 930,
	684, 678, -1000, -1000, -116, -116, -36, -116, 251, 5543,
	248, -116, -116, -116, -116, -116, -116, -116, -1000, 7122,
	-1000, 7777, 7777, 7777, 478, 768, 779, -1000, 262, 7932,
	536, 6075, 172, 270, 664, -1000, 542, 599, 930, 722,
	152, 156, 651, 7777, 7777, 5863, 5863, 7777, 5863, 5863,
	7777, 657, 768, 743, -1000, 713, 7777, 6991, 167, 23,
	5499, 536, 7777, 7777, 953, -1000, 6288, 272, 264, 7777,
	7777, 152, 462, 175, -1000, 7777, 426, -1000, -1000, 2412,
	272, -1000, 655, 18, -1000, 642, 930, 3, -1000, 638,
	930, 952, 637, -35, 8223, -1000, -1000, -1000, -1000, -1000,
	319, 5032, -1000, -1000, 813, 424, 17, 5863, 344, -1000,
	-1000, -1000, -1000, -1000, -1000, 171, -1000, 7777, -1000, -1000,
	886, -1000, 8223, -1000, 7777, 7777, 7777, 7777, 7777, 6034,
	6827, 6285, 7120, -31, -31, -31, -36, -116, -36, -36,
	99, 99, 261, 261, 261, 261, 428, 428, 428, 428,
	-1000, 7777, -1000, 32, -1000, -1000, 865, 792, 949, 4115,
	-1000, -1000, -1000, 318, -1000, 689, 732, 7777, 6075, 357,
	6075, 6075, 6075, 6075, 6075, 6075, 6075, 6075, 6075, 6075,
	6075, 6075, 2, -1000, -1000, 315, 930, 272, 172, 172,
	-1000, -1000, -1000, -1000, -116, 163, 5863, 160, -1000, -1000,
	-1000, -1000, 896, 948, 5418, 185, 442, -1000, 193, -1000,
	-1000, 152, 156, -1000, 7777, -1000, -1000, 153, 930, 542,
	172, 152, 153, -5, -1000, 1236, -1000, 959, 246, 5370,
	159, -1000, -1000, -1000, 157, 239, -1000, -1000, 6841, 6710,
	-1000, -1000, 155, 146, -1000, -1000, -18, 238, -1000, -1000,
	1236, 536, 7777, -1000, 270, 270, -1000, -1000, 134, 5326,
	270, 270, -1000, 5278, -1000, 2267, -1000, -1000, -1000, -1000,
	621, 942, 601, -1000, 619, 939, 594, -1000, 937, 8223,
	-1000, 5819, -1000, -1000, 542, 597, 930, 314, 8223, -1000,
	-1000, -1000, -1000, 749, 634, 8223, 8223, 8223, 8223, 8223,
	232, -1000, -1000, 4901, -1000, -1000, -1000, -1000, 423, 421,
	-1000, 5230, -44, 311, -1000, 5863, 6157, 6405, 5949, 6075,
	5182, 7777, 420, 536, 374, 374, -33, -57, 769, 278,
	612, 730, -1000, 542, 596, 930, 461, 689, -1000, 1236,
	-1000, 598, -59, 672, 672, 272, -1000, -1000, -1000, 112,
	-1000, -1000, -1000, -1000, -1000, 7777, -1000, -1000, 178, 173,
	270, 7777, 7777, 152, 5136, -1000, 542, -1000, -1000, -1000,
	7777, -1000, -1000, -1000, -1000, -1000, -1000, 5088, 536, 5863,
	536, -1000, -1000, -1000, 6419, -1000, -1000, 5863, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, 936, -1000,
	-1000, 934, -1000, -1000, 8223, 8223, 8223, 8223, 8223, 8223,
	8223, 8223, 8223, 8223, 8223, 8223, 8223, 8223, 8223, 8223,
	8223, 8223, 8223, 8223, 8223, 8223, 8223, 8223, 8223, 8223,
	8148, 930, 542, 8223, 111, -12, 5044, 641, 805, -67,
	-67, -3, -3, 2079, 418, -1000, 4377, -1000, -1000, -1000,
	265, 7777, 7777, 483, -1000, 870, -1000, -1000, 8223, 612,
	-1000, 6116, -1000, -1000, 709, -1000, 536, 276, 709, 4770,
	932, 8223, 770, 271, 612, 228, -19, -1000, 47, -1000,
	-1000, -1000, 460, 689, 930, 542, -1000, -24, -1000, -1000,
	7777, -1000, -46, -1000, 177, -1000, 1994, 715, 7777, 7777,
	-1000, 100, 1350, -1000, 716, -1000, 6579, -1000, -1000, -1000,
	-1000, -1000, 1866, -3, -3, -67, -67, -67, -67, 6448,
	249, 7768, 321, 321, -3, 5992, 1195, 5906, 44, 1935,
	-16, -16, -16, -16, -68, -68, -68, -68, 8223, 1663,
	542, 224, -1000, -1000, 8223, 8223, -1000, -1000, -1000, -1000,
	527, -1000, 3984, 416, 412, 5863, -1000, 7777, 309, 467,
	411, 864, -1000, 220, 7777, 212, 374, -1000, 672, 211,
	-1000, -1000, -1000, -60, -1000, -1000, -1000, -1000, 210, 756,
	612, 516, -1000, -24, 542, 1087, 689, 270, 6075, -1000,
	-1000, 154, 715, 7777, -1000, 172, 440, -1000, 89, 88,
	-1000, -1000, -1000, 172, 5863, 536, -1000, 1807, 8223, -1000,
	1095, 5819, -1000, 265, 5032, 511, 404, -1000, -1000, 91,
	-1000, -1000, -1000, -1000, -1000, 403, 756, 6116, 4639, -1000,
	-49, 4639, 3853, 8223, 458, 689, 454, 452, 269, -1000,
	881, -1000, 988, -1000, -1000, -1000, -47, -1000, 776, 647,
	-1000, 928, 689, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, 7777, 715, -1000, 67, -1000, -1000, -1000, -1000,
	-1000, -1000, 1807, 8223, -1000, -1000, 183, 265, 221, -1000,
	7777, -1000, -1000, -1000, 451, -1000, -1000, -1000, -1000, -1000,
	402, -1000, -1000, -1000, -1000, -1000, 219, -64, -1000, 877,
	-1000, 895, 47, -1000, -65, -54, -1000, 64, 715, -1000,
	-1000, 5819, 5032, 401, 174, -1000, 209, -1000, 4377, -1000,
	3722, -1000, 3591, 869, 3460, 3329, -51, -1000, 853, 8223,
	-52, -66, -70, 889, 8223, -1000, 689, -1000, 699, -1000,
	-1000, -1000, -1000, -1000, 4377, -1000, 4377, 3198, 400, -1000,
	203, -1000, -1000, -1000, 204, -1000, -1000, -1000, 848, 8223,
	8223, -1000, -1000, -1000, 429, 699, -1000, 399, 391, 750,
	787, 628, -1000, -1000, 4508, -1000, -1000, -1000, -1000, 841,
	-76, -1000, -1000, 258, -1000, -1000, -1000, -1000, 689, 647,
	872, 4377, -1000, -1000, -1000, 450, -1000, 8223, 612, -27,
	-1000, 866, -1000, -1000, 3067, -1000, -1000, 176, 689, -1000,
	386, 2936, 385, -1000, -1000, -1000, -1000, -1000, -1000, 766,
	2805, -1000, 766, -1000, 257, -1000, -1000, 689, -1000, 836,
	158, -1000, 445, -1000, 2674, -1000,
}
var yyPgo = [...]int{

	0, 1239, 45, 37, 35, 632, 1237, 1236, 25, 275,
	1149, 14, 1389, 85, 63, 16, 823, 1646, 1234, 40,
	1233, 1232, 1231, 18, 1230, 43, 24, 1228, 1227, 1226,
	1221, 82, 1219, 1218, 32, 1217, 33, 38, 166, 1216,
	808, 44, 1215, 52, 0, 1214, 1213, 1211, 30, 1210,
	1209, 668, 1208, 1206, 53, 23, 41, 28, 20, 1203,
	1202, 1201, 19, 267, 1200, 47, 39, 1199, 46, 1198,
	1197, 1196, 1195, 1194, 1192, 1191, 1181, 1180, 1178, 1177,
	1176, 1175, 26, 1174, 1172, 1171, 1170, 1169, 1168, 49,
	1167, 1166, 29, 7, 1165, 1164, 1163, 1157, 1156, 1155,
	154, 1154, 1148, 1147, 1146, 1145, 1144, 1, 1143, 1141,
	34, 1140, 1137, 8, 1136, 87, 1135, 2, 1133, 1132,
	1130, 1128, 13, 1127, 1126, 1124, 22, 36, 11, 1120,
	1119, 1118, 1117, 1116, 17, 1115, 1113, 48, 1112, 1110,
	1093, 1092, 1084, 1082, 1081, 1080, 1078, 1077, 1076, 1075,
	1073, 3, 1071, 1070, 1069, 1068, 1067, 1063, 5, 1061,
	1060, 1059, 6, 12, 1057, 1056, 1053, 1049, 1048, 1047,
	1046, 1045, 1041, 1033, 1030, 1027, 1024, 1022, 1021, 1018,
	1017, 1016, 998, 997, 15, 995, 994, 1238, 31, 993,
	988, 27, 4, 987, 986, 983, 982, 981,
}
var yyR1 = [...]int{

	0, 64, 43, 43, 44, 44, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 45, 45, 2,
	2, 2, 2, 46, 46, 3, 3, 3, 3, 47,
	47, 4, 4, 4, 4, 67, 67, 48, 48, 22,
	22, 22, 22, 23, 23, 24, 69, 70, 24, 73,
	74, 24, 77, 78, 24, 80, 81, 24, 83, 84,
	85, 24, 87, 24, 24, 24, 24, 24, 24, 24,
	24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
	94, 24, 24, 24, 24, 24, 97, 99, 101, 102,
	103, 97, 98, 105, 98, 104, 104, 106, 106, 108,
	109, 107, 91, 91, 110, 65, 66, 113, 113, 114,
	114, 116, 111, 120, 112, 124, 112, 118, 118, 118,
	118, 119, 119, 123, 125, 125, 121, 121, 126, 126,
	92, 92, 57, 57, 57, 86, 86, 93, 93, 96,
	96, 95, 95, 88, 88, 88, 88, 127, 129, 127,
	130, 127, 128, 128, 79, 79, 71, 131, 71, 75,
	132, 75, 72, 72, 76, 76, 117, 117, 133, 133,
	134, 134, 135, 135, 135, 135, 63, 63, 63, 136,
	136, 137, 137, 137, 137, 49, 49, 25, 25, 25,
	50, 50, 50, 50, 122, 122, 140, 138, 138, 138,
	145, 138, 143, 147, 147, 148, 148, 149, 149, 150,
	150, 151, 151, 152, 155, 155, 156, 156, 154, 153,
	153, 157, 157, 146, 146, 139, 139, 144, 144, 159,
	159, 158, 158, 158, 158, 158, 158, 141, 141, 141,
	141, 142, 142, 90, 90, 82, 82, 161, 160, 160,
	162, 162, 164, 164, 166, 165, 165, 165, 167, 168,
	167, 40, 13, 13, 13, 169, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 170, 13, 171, 13, 172, 13,
	173, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	174, 13, 175, 176, 13, 177, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 179, 13, 13, 13,
	13, 13, 13, 13, 183, 13, 185, 13, 89, 89,
	89, 89, 180, 180, 180, 180, 181, 181, 115, 184,
	184, 186, 186, 186, 186, 21, 21, 21, 21, 21,
	21, 21, 21, 9, 9, 9, 9, 100, 100, 100,
	41, 41, 39, 39, 60, 60, 61, 178, 178, 178,
	182, 182, 182, 62, 62, 5, 5, 5, 5, 5,
	5, 5, 5, 5, 5, 5, 5, 6, 26, 187,
	187, 187, 187, 187, 187, 187, 187, 187, 187, 189,
	189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
	189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
	189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
	189, 189, 33, 33, 33, 33, 27, 27, 27, 27,
	27, 27, 27, 188, 188, 191, 191, 190, 190, 190,
	190, 12, 12, 68, 68, 14, 15, 16, 17, 17,
	193, 193, 194, 163, 195, 195, 197, 196, 192, 192,
	192, 38, 38, 42, 42, 10, 20, 20, 18, 18,
	18, 19, 19, 19, 8, 8, 8, 7, 7, 11,
	11, 58, 58, 59, 59, 59, 37, 37, 56, 56,
	55, 55, 36, 36, 36, 54, 54, 53, 53, 53,
	53, 53, 53, 53, 53, 51, 51, 51, 51, 31,
	31, 31, 31, 31, 31, 32, 32, 32, 35, 35,
	35, 35, 35, 35, 35, 35, 52, 52, 34, 34,
	28, 28, 29, 30,
}
var yyR2 = [...]int{

	0, 1, 2, 0, 1, 3, 1, 1, 1, 4,
	3, 5, 4, 3, 4, 4, 2, 3, 1, 1,
	3, 2, 4, 3, 1, 1, 3, 2, 4, 3,
	1, 1, 3, 2, 4, 5, 4, 2, 0, 1,
	1, 1, 4, 1, 2, 3, 0, 0, 7, 0,
	0, 10, 0, 0, 5, 0, 0, 7, 0, 0,
	0, 12, 0, 4, 2, 3, 2, 3, 2, 3,
	3, 2, 3, 3, 3, 1, 2, 5, 8, 8,
	0, 6, 1, 6, 3, 3, 0, 0, 0, 0,
	0, 13, 0, 0, 5, 1, 0, 1, 2, 0,
	0, 10, 1, 3, 1, 1, 1, 0, 1, 0,
	1, 0, 10, 0, 8, 0, 7, 1, 2, 1,
	2, 0, 2, 1, 0, 2, 0, 2, 1, 3,
	0, 2, 1, 2, 4, 1, 4, 1, 4, 1,
	4, 3, 5, 3, 4, 4, 5, 0, 0, 6,
	0, 5, 1, 1, 1, 4, 0, 0, 5, 0,
	0, 6, 0, 2, 0, 3, 1, 0, 1, 3,
	4, 6, 0, 1, 1, 1, 2, 3, 3, 1,
	3, 1, 1, 2, 2, 3, 1, 1, 2, 4,
	3, 5, 1, 3, 2, 0, 0, 4, 2, 1,
	0, 9, 3, 1, 3, 1, 3, 0, 1, 1,
	2, 2, 2, 3, 1, 3, 1, 1, 3, 4,
	3, 0, 1, 1, 3, 1, 1, 0, 1, 1,
	2, 1, 1, 1, 1, 1, 1, 3, 5, 1,
	3, 5, 4, 3, 1, 0, 1, 0, 4, 1,
	2, 1, 4, 3, 0, 3, 1, 1, 0, 0,
	2, 3, 6, 3, 4, 0, 7, 2, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	2, 2, 2, 2, 0, 4, 0, 4, 0, 4,
	0, 4, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 2, 2, 2, 2, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 1, 1,
	0, 5, 0, 0, 7, 0, 5, 1, 2, 2,
	2, 2, 2, 2, 2, 2, 0, 3, 1, 1,
	1, 3, 2, 1, 0, 10, 0, 11, 2, 2,
	4, 4, 4, 4, 4, 4, 4, 3, 1, 0,
	4, 3, 4, 1, 2, 2, 4, 3, 4, 4,
	4, 4, 2, 1, 1, 3, 2, 1, 3, 2,
	1, 1, 4, 1, 2, 0, 2, 0, 2, 1,
	0, 1, 1, 0, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 3, 2, 3, 1, 1,
	1, 1, 3, 2, 4, 3, 1, 1, 1, 4,
	3, 3, 3, 3, 3, 3, 2, 2, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 4, 5, 2,
	2, 3, 1, 1, 3, 2, 1, 1, 1, 1,
	3, 3, 1, 0, 2, 0, 1, 5, 3, 3,
	1, 1, 1, 3, 3, 1, 1, 1, 5, 1,
	2, 0, 0, 4, 4, 4, 0, 2, 1, 1,
	0, 1, 2, 3, 3, 1, 4, 4, 1, 1,
	1, 1, 2, 1, 4, 4, 1, 1, 4, 0,
	1, 1, 1, 4, 4, 1, 1, 3, 1, 2,
	3, 1, 1, 4, 0, 0, 2, 5, 3, 3,
	1, 6, 4, 4, 2, 2, 2, 1, 2, 1,
	4, 3, 3, 6, 3, 1, 1, 1, 4, 4,
	4, 2, 2, 4, 2, 2, 1, 3, 1, 1,
	3, 3, 3, 3,
}
var yyChk = [...]int{

	-1000, -64, -43, -1, -23, -65, -66, 51, 79, 44,
	-67, -24, 10, -111, -112, 38, 119, 7, 21, 20,
	23, 30, 34, 35, 39, -89, 46, 98, 19, 14,
	-12, 48, 25, 27, 121, 40, 43, 36, -115, -118,
	-123, 97, -14, -13, 37, 52, 99, 53, 100, 54,
	-17, 59, 92, -16, 104, 105, 130, 129, 131, 132,
	-68, -40, 123, -35, 107, 108, 109, 110, 111, 112,
	113, 6, 133, -27, -180, -181, 118, 96, -18, 91,
	49, 50, 4, 5, 84, 85, 86, 11, -33, -30,
	-5, 117, 74, 62, 18, 60, 125, -19, -20, -21,
	-28, -44, 82, -9, 8, 9, 66, 67, 81, 63,
	64, 65, 80, -8, -56, -42, -10, -38, -7, 134,
	12, 123, -44, 119, 82, 10, -45, 37, 38, -2,
	-44, 82, 121, 135, 122, 10, -48, -68, 123, -77,
	-80, 123, -68, 121, -12, 97, -115, 98, 79, 121,
	-12, 121, -13, -17, -12, 121, -49, -25, 12, 134,
	-50, -115, 12, -90, -12, 121, 149, 150, 87, 89,
	88, 151, 128, 152, 163, 130, 129, 164, 167, 165,
	166, 161, 162, 155, 156, 153, 154, 157, 158, 159,
	160, 90, 127, 123, 123, -94, 119, -12, 10, -113,
	128, 10, 10, -13, -17, -12, 52, 52, 136, 137,
	138, 139, 148, 140, 141, 142, 143, 144, 145, 146,
	147, 123, -12, 104, 105, -16, -17, -44, 79, 82,
	-9, -10, 98, -16, -12, -12, -12, -12, -40, -12,
	-89, -12, -12, -12, -12, -12, -12, -12, -178, 123,
	-68, -179, 125, 125, -182, 17, -51, -31, 12, 76,
	77, -12, 57, -41, -9, -39, -44, 79, 82, -19,
	-8, -56, -10, 123, 123, -12, -12, 123, -12, -12,
	125, -51, 17, 17, 75, -51, 125, 123, -54, -53,
	-12, 128, 125, 125, 82, -63, 123, -44, 78, 125,
	119, -8, 134, 78, -63, 119, 124, 121, 119, -43,
	-44, 121, 135, -46, -3, -44, 82, -47, -4, -44,
	82, 29, -44, 10, 136, -22, 120, -23, -65, -66,
	51, -69, 122, -68, -23, -82, -160, -12, -87, 121,
	-113, 121, 121, 121, 121, 135, -14, 119, -17, 121,
	135, -113, 136, 121, 135, -170, -171, -172, -173, -12,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -12,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -12,
	-41, -175, 122, -91, -110, -17, -17, -13, 123, -48,
	121, 121, 10, -183, -119, 55, -124, 58, -12, 128,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -12,
	-12, -12, -55, -36, -17, 59, 82, -44, 78, 78,
	124, 124, 124, 124, -12, -11, -12, -11, 118, -31,
	-31, 17, 125, 57, -12, 11, -17, -58, -59, -38,
	-37, -8, -56, 10, 119, -62, -63, 78, 82, -44,
	57, -8, 78, -52, -34, -17, -13, -17, -13, -12,
	-11, 117, 75, 75, -11, -54, 126, -191, 135, 58,
	-15, -17, -11, -11, 10, 124, -136, -89, -137, -13,
	-17, 128, 83, -63, -37, -38, 10, 52, -11, -12,
	-37, -38, 10, -12, 121, -43, 120, -63, -2, 121,
	135, 29, -44, 121, 135, 29, -44, 10, 29, 136,
	-26, -187, -5, -29, -44, 79, 82, 60, 125, -6,
	62, -189, 18, 74, -9, 131, 132, 130, 129, 123,
	123, -23, -73, -78, 21, 121, 135, -88, 119, 122,
	-25, -12, 12, -185, -26, -12, -12, -12, -12, -12,
	-12, -177, 124, 135, 29, 29, -95, 10, 120, -116,
	123, -120, -100, -44, 79, 82, -125, 55, -13, -17,
	-17, 91, 124, 135, 123, -44, -174, 126, 126, -32,
	10, 13, 12, 10, 120, 125, 120, -192, -196, -195,
	-197, 125, 119, -8, -12, -38, -44, -58, -38, 124,
	135, 124, 124, 124, 126, 126, 124, -12, 128, -12,
	128, 126, 126, 124, 135, 124, -15, -12, -63, -63,
	126, 120, -63, -63, 120, 120, -3, 10, 29, -4,
	10, 29, 10, -26, 125, 130, 129, 164, 167, 165,
	166, 151, 128, 152, 161, 162, 163, 88, 89, 87,
	150, 149, 155, 156, 153, 154, 157, 159, 158, 160,
	127, 82, -44, 123, -188, -190, -187, 17, 78, -187,
	-187, -187, -187, -187, 124, -70, -48, -79, -23, 122,
	-81, -83, -161, -127, 121, -127, 121, 120, 136, 123,
	122, -12, 121, -110, -57, -17, 128, 59, -57, 124,
	135, 136, -97, 41, 123, -117, -133, -134, -135, 60,
	61, -100, -121, 56, 82, -44, 119, -126, -100, -41,
	136, -36, -55, -167, -168, 126, -12, -193, 125, 125,
	-63, -11, -12, 120, -60, -34, 58, -15, -15, -137,
	10, 10, -187, -187, -187, -187, -187, -187, -187, -187,
	-187, -187, -187, -187, -187, -187, -187, -187, -187, -187,
	-187, -187, -187, -187, -187, -187, -187, -187, 122, -187,
	-44, -188, 126, -191, 135, 58, 10, 52, 124, 121,
	-71, -74, -48, -68, -82, -12, 120, 32, 33, -127,
	31, -127, -26, -117, -176, -92, 58, -17, 123, -92,
	-96, -23, 122, 10, -26, -98, 42, 123, -117, 124,
	135, -113, 119, -126, -44, -122, 135, -169, -12, 124,
	-165, -164, -162, 125, -163, 57, 126, -163, -11, -11,
	126, 120, -61, 57, -12, 128, 126, -187, 122, 124,
	-187, -187, -72, 93, 94, -75, 22, 121, 121, -12,
	-128, 122, 121, 120, 121, 31, 124, -12, 124, -57,
	-55, 124, -48, 136, -105, -99, 124, -184, 44, -134,
	-114, 83, -122, 120, -138, -139, -142, -143, -144, -159,
	47, 38, 44, -158, 103, 102, 101, 98, 99, 100,
	-100, -62, 125, -166, -163, -11, -58, 120, 126, 126,
	-58, -15, -187, 58, -68, -23, -76, 93, 94, 121,
	-84, -128, -130, 121, -184, -93, -23, 122, 124, -93,
	28, -26, 119, -100, 119, 119, 123, 12, 120, -140,
	121, 135, -115, -158, 10, -147, -100, -11, -162, 126,
	-194, -187, -131, 95, -68, 122, -82, -129, -48, 119,
	-48, 121, -48, -101, -48, -48, -186, 12, 128, 136,
	-141, 12, 10, -113, 136, -148, 135, 121, 119, 126,
	-192, -23, 121, 122, -48, 124, -48, -48, 26, 120,
	12, 120, 120, 124, 135, 12, -26, 121, 135, 136,
	136, 10, -26, -100, -149, -150, -151, -152, -153, -154,
	-156, -100, 10, -132, -85, 120, 121, 124, 12, 128,
	12, -26, -26, -145, 120, -151, 121, 121, 45, 29,
	78, -48, -86, -23, 122, -102, 12, 136, 123, -155,
	-100, -157, -158, 10, -48, 119, -26, -117, 135, 10,
	24, -48, 124, -100, 121, 120, -146, 121, 119, -103,
	-48, -104, -106, -107, 41, 120, -107, 123, -100, -108,
	12, 124, -109, 119, -48, 120,
}
var yyDef = [...]int{

	3, -2, 1, 2, 6, 7, 8, 0, 0, 0,
	0, 43, 4, 105, 106, 0, 38, 0, 52, 55,
	0, 0, 0, 0, 0, 0, 0, 373, 0, 75,
	0, 0, 0, 80, 82, 0, 0, 0, 107, 0,
	0, 343, 471, 472, 358, 117, 0, 119, 0, 123,
	-2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	318, 319, 0, 327, 0, 0, 0, 0, 0, 0,
	0, 387, 336, 338, 339, 340, 390, 0, 479, 0,
	0, 0, 0, 0, 0, 0, 0, 456, 457, 458,
	459, 0, 0, 462, 397, 0, 525, 498, 499, 500,
	452, -2, 0, 0, 395, 396, 398, 399, 400, 401,
	402, 403, 404, -2, 0, 503, 0, 0, 506, 518,
	507, 0, 0, 3, 0, 4, 0, 0, 0, 18,
	19, 0, 16, 0, 44, 0, 0, 46, 0, 0,
	0, 245, 62, 64, 0, 343, 107, 373, 0, 66,
	0, 68, 472, -2, 0, 71, 0, 186, 187, 0,
	0, 107, 192, 0, 244, 76, 284, 286, 288, 290,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 322, 0, 0, 0, 38, 0, 0, 344,
	108, 121, 115, -2, -2, 0, 118, 120, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 524, 267, 280, 282, 281, 477, 374, 0, 0,
	0, 0, 373, 283, 305, 306, 307, 308, 319, 0,
	0, 328, 329, 330, 331, 332, 333, 334, 335, 0,
	389, 0, 509, 509, 0, 391, 392, 537, 539, 0,
	0, 342, 0, 393, 380, 381, 374, 0, 0, 383,
	-2, 0, 0, 0, 0, 551, 552, 0, 554, 555,
	509, 0, 0, 0, 406, 0, 509, 525, 0, 465,
	530, 0, 509, 509, 0, 365, 0, -2, 0, 509,
	0, -2, 519, 0, 372, 0, 0, 10, 3, 0,
	-2, 13, 0, 0, 24, 25, 0, 0, 30, 31,
	0, 0, 21, 0, 0, 37, 45, 39, 40, 41,
	0, 0, 49, 53, 0, 0, 246, 249, 0, 65,
	344, 67, 69, 70, 72, 0, 188, 0, 475, 73,
	0, 346, 0, 74, 0, 0, 0, 0, 0, 292,
	293, 294, 295, 296, 297, 298, 299, 300, 301, 302,
	303, 304, -2, -2, -2, -2, -2, -2, -2, -2,
	317, 0, 325, 0, 102, 104, -2, 472, 0, 0,
	84, 85, 111, 0, 113, 0, 124, 0, 263, 0,
	268, 269, 270, 271, 272, 273, 274, 275, 276, 277,
	278, 279, 0, 521, 522, 0, 0, 376, 0, 0,
	320, 473, 474, 388, 337, 0, 510, 0, 341, 538,
	535, 536, 0, 0, 0, 456, 0, -2, 511, 512,
	515, 491, 0, 516, 0, 261, 394, 0, 0, 376,
	0, 502, 0, 0, 556, -2, -2, -2, 472, 0,
	0, 460, 405, 461, 0, 0, 357, 526, 466, 0,
	534, 476, 0, 0, 5, 176, 0, 0, 179, -2,
	-2, 0, 0, 367, 0, 493, -2, 563, 0, 0,
	0, 494, -2, 0, 9, 0, 12, 366, 17, 14,
	0, 0, 27, 15, 0, 0, 33, 20, 0, 0,
	36, 408, 409, 410, -2, 0, 0, 0, 463, 416,
	417, 418, 397, 0, 0, 0, 0, 0, 0, 0,
	0, 47, 38, 0, 56, 58, 247, 63, 147, 147,
	185, 0, 190, 0, 193, 243, 285, 287, 289, 291,
	0, 0, 0, 0, 0, 0, 0, 0, 86, 0,
	-2, 126, 122, 377, 0, 0, 0, 0, -2, -2,
	264, 0, 0, 524, 524, 375, -2, 353, 352, 0,
	545, 546, 547, 541, 542, 0, 544, 481, 488, 489,
	0, 509, 0, 492, 0, 493, 375, 385, 494, 548,
	0, 549, 550, 553, 355, 354, 356, 528, 0, 529,
	0, 496, 497, 177, 0, 178, 183, 184, 368, 369,
	504, 505, 370, 371, 508, 11, 23, 26, 0, 29,
	32, 0, 22, 35, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, -2, 463, 0, 465, 470, 0, 0, 426,
	427, 449, 450, 0, 0, 156, 50, 54, 154, 38,
	0, 245, 0, 0, 147, 0, 147, 189, 0, -2,
	323, 326, 77, 103, 130, 132, 0, 0, 130, 0,
	0, 0, 92, 0, -2, 0, 166, 168, 107, 173,
	174, 175, 0, 0, 0, 379, 195, 125, 128, 265,
	0, 520, 0, 321, 0, 540, 0, 478, 509, 509,
	487, 0, 0, 517, 382, 557, 0, 532, 533, 180,
	28, 34, 0, 420, 421, 422, 423, 424, 425, 428,
	429, 430, 431, 432, 433, 434, 435, 436, 437, 438,
	-2, -2, -2, -2, -2, -2, -2, -2, 0, 0,
	-2, 0, 415, 464, 466, 0, 407, 562, 451, 42,
	162, 159, 0, 0, 0, 248, 143, 0, 0, 0,
	0, 0, 191, 0, 0, 0, 0, 133, 524, 0,
	81, 139, 38, 0, 141, 83, 93, 87, 0, 359,
	172, 109, 195, 127, 378, 227, 0, 393, 262, 523,
	260, -2, 257, 509, 251, 0, 0, 480, 0, 0,
	513, 514, 384, 0, 527, 0, 419, 447, 0, 414,
	468, 469, 48, 0, 0, 164, 0, 57, 59, 0,
	150, 152, 153, 144, 145, 0, 359, 324, 0, 131,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 169,
	0, 110, 227, 116, 194, 196, 0, 199, 0, -2,
	226, 0, 0, 229, 231, 232, 233, 234, 235, 236,
	129, 266, 509, 0, 250, 0, 482, 543, 485, 484,
	386, 531, 448, 0, 157, 163, 0, 0, 0, 155,
	245, 148, 38, 146, 0, 78, 137, 38, 134, 79,
	0, 142, 38, 88, 38, 38, 0, 170, 114, 0,
	198, 0, 107, 230, 0, 0, 203, 0, 255, 253,
	-2, 467, 0, 0, 0, 38, 0, 38, 151, 38,
	0, 140, 0, 0, 0, 0, 0, 363, 0, 0,
	0, 239, 0, 0, 0, 202, 0, 205, 207, 252,
	483, 158, 51, 160, 165, 60, 149, 0, 0, 94,
	0, 112, 345, 360, 0, 364, 171, 197, 0, 0,
	0, 200, 242, 204, 0, 208, 209, 0, 0, 217,
	0, 0, -2, 38, 0, 347, 138, 89, 361, 0,
	237, 240, 241, 0, 206, 210, 211, 212, 0, 221,
	0, 161, 61, 135, 38, 0, 362, 0, -2, 213,
	214, 0, -2, 218, 0, 38, 238, 0, 0, 219,
	0, 0, 0, 215, 136, 90, 201, 223, 38, 96,
	0, 91, 95, 97, 0, 224, 98, 0, 99, 0,
	0, 100, 0, 38, 0, 101,
}
var yyTok1 = [...]int{

	1, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 131, 117, 3, 134, 166, 128, 3,
	123, 124, 164, 130, 135, 129, 163, 165, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 122, 121,
	157, 136, 159, 127, 133, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 125, 3, 126, 152, 3, 118, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 119, 151, 120, 132,
}
var yyTok2 = [...]int{

	2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
	22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	32, 33, 34, 35, 36, 37, 38, 39, 40, 41,
	42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
	52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
	62, 63, 64, 65, 66, 67, 68, 69, 70, 71,
	72, 73, 74, 75, 76, 77, 78, 79, 80, 81,
	82, 83, 84, 85, 86, 87, 88, 89, 90, 91,
	92, 93, 94, 95, 96, 97, 98, 99, 100, 101,
	102, 103, 104, 105, 106, 107, 108, 109, 110, 111,
	112, 113, 114, 115, 116, 137, 138, 139, 140, 141,
	142, 143, 144, 145, 146, 147, 148, 149, 150, 153,
	154, 155, 156, 158, 160, 161, 162, 167,
}
var yyTok3 = [...]int{
	0,
}

var yyErrorMessages = [...]struct {
	state int
	token int
	msg   string
}{}

//line yaccpar:1

/*	parser for yacc output	*/

var (
	yyDebug        = 0
	yyErrorVerbose = false
)

type yyLexer interface {
	Lex(lval *yySymType) int
	Error(s string)
}

type yyParser interface {
	Parse(yyLexer) int
	Lookahead() int
}

type yyParserImpl struct {
	lval  yySymType
	stack [yyInitialStackSize]yySymType
	char  int
}

func (p *yyParserImpl) Lookahead() int {
	return p.char
}

func yyNewParser() yyParser {
	return &yyParserImpl{}
}

const yyFlag = -1000

func yyTokname(c int) string {
	if c >= 1 && c-1 < len(yyToknames) {
		if yyToknames[c-1] != "" {
			return yyToknames[c-1]
		}
	}
	return __yyfmt__.Sprintf("tok-%v", c)
}

func yyStatname(s int) string {
	if s >= 0 && s < len(yyStatenames) {
		if yyStatenames[s] != "" {
			return yyStatenames[s]
		}
	}
	return __yyfmt__.Sprintf("state-%v", s)
}

func yyErrorMessage(state, lookAhead int) string {
	const TOKSTART = 4

	if !yyErrorVerbose {
		return "syntax error"
	}

	for _, e := range yyErrorMessages {
		if e.state == state && e.token == lookAhead {
			return "syntax error: " + e.msg
		}
	}

	res := "syntax error: unexpected " + yyTokname(lookAhead)

	// To match Bison, suggest at most four expected tokens.
	expected := make([]int, 0, 4)

	// Look for shiftable tokens.
	base := yyPact[state]
	for tok := TOKSTART; tok-1 < len(yyToknames); tok++ {
		if n := base + tok; n >= 0 && n < yyLast && yyChk[yyAct[n]] == tok {
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}
	}

	if yyDef[state] == -2 {
		i := 0
		for yyExca[i] != -1 || yyExca[i+1] != state {
			i += 2
		}

		// Look for tokens that we accept or reduce.
		for i += 2; yyExca[i] >= 0; i += 2 {
			tok := yyExca[i]
			if tok < TOKSTART || yyExca[i+1] == 0 {
				continue
			}
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}

		// If the default action is to accept or reduce, give up.
		if yyExca[i+1] != 0 {
			return res
		}
	}

	for i, tok := range expected {
		if i == 0 {
			res += ", expecting "
		} else {
			res += " or "
		}
		res += yyTokname(tok)
	}
	return res
}

func yylex1(lex yyLexer, lval *yySymType) (char, token int) {
	token = 0
	char = lex.Lex(lval)
	if char <= 0 {
		token = yyTok1[0]
		goto out
	}
	if char < len(yyTok1) {
		token = yyTok1[char]
		goto out
	}
	if char >= yyPrivate {
		if char < yyPrivate+len(yyTok2) {
			token = yyTok2[char-yyPrivate]
			goto out
		}
	}
	for i := 0; i < len(yyTok3); i += 2 {
		token = yyTok3[i+0]
		if token == char {
			token = yyTok3[i+1]
			goto out
		}
	}

out:
	if token == 0 {
		token = yyTok2[1] /* unknown char */
	}
	if yyDebug >= 3 {
		__yyfmt__.Printf("lex %s(%d)\n", yyTokname(token), uint(char))
	}
	return char, token
}

func yyParse(yylex yyLexer) int {
	return yyNewParser().Parse(yylex)
}

func (yyrcvr *yyParserImpl) Parse(yylex yyLexer) int {
	var yyn int
	var yyVAL yySymType
	var yyDollar []yySymType
	_ = yyDollar // silence set and not used
	yyS := yyrcvr.stack[:]

	Nerrs := 0   /* number of errors */
	Errflag := 0 /* error recovery flag */
	yystate := 0
	yyrcvr.char = -1
	yytoken := -1 // yyrcvr.char translated into internal numbering
	defer func() {
		// Make sure we report no lookahead when not parsing.
		yystate = -1
		yyrcvr.char = -1
		yytoken = -1
	}()
	yyp := -1
	goto yystack

ret0:
	return 0

ret1:
	return 1

yystack:
	/* put a state and value onto the stack */
	if yyDebug >= 4 {
		__yyfmt__.Printf("char %v in %v\n", yyTokname(yytoken), yyStatname(yystate))
	}

	yyp++
	if yyp >= len(yyS) {
		nyys := make([]yySymType, len(yyS)*2)
		copy(nyys, yyS)
		yyS = nyys
	}
	yyS[yyp] = yyVAL
	yyS[yyp].yys = yystate

yynewstate:
	yyn = yyPact[yystate]
	if yyn <= yyFlag {
		goto yydefault /* simple state */
	}
	if yyrcvr.char < 0 {
		yyrcvr.char, yytoken = yylex1(yylex, &yyrcvr.lval)
	}
	yyn += yytoken
	if yyn < 0 || yyn >= yyLast {
		goto yydefault
	}
	yyn = yyAct[yyn]
	if yyChk[yyn] == yytoken { /* valid shift */
		yyrcvr.char = -1
		yytoken = -1
		yyVAL = yyrcvr.lval
		yystate = yyn
		if Errflag > 0 {
			Errflag--
		}
		goto yystack
	}

yydefault:
	/* default state action */
	yyn = yyDef[yystate]
	if yyn == -2 {
		if yyrcvr.char < 0 {
			yyrcvr.char, yytoken = yylex1(yylex, &yyrcvr.lval)
		}

		/* look through exception table */
		xi := 0
		for {
			if yyExca[xi+0] == -1 && yyExca[xi+1] == yystate {
				break
			}
			xi += 2
		}
		for xi += 2; ; xi += 2 {
			yyn = yyExca[xi+0]
			if yyn < 0 || yyn == yytoken {
				break
			}
		}
		yyn = yyExca[xi+1]
		if yyn < 0 {
			goto ret0
		}
	}
	if yyn == 0 {
		/* error ... attempt to resume parsing */
		switch Errflag {
		case 0: /* brand new error */
			yylex.Error(yyErrorMessage(yystate, yytoken))
			Nerrs++
			if yyDebug >= 1 {
				__yyfmt__.Printf("%s", yyStatname(yystate))
				__yyfmt__.Printf(" saw %s\n", yyTokname(yytoken))
			}
			fallthrough

		case 1, 2: /* incompletely recovered error ... try again */
			Errflag = 3

			/* find a state where "error" is a legal shift action */
			for yyp >= 0 {
				yyn = yyPact[yyS[yyp].yys] + yyErrCode
				if yyn >= 0 && yyn < yyLast {
					yystate = yyAct[yyn] /* simulate a shift of "error" */
					if yyChk[yystate] == yyErrCode {
						goto yystack
					}
				}

				/* the current p has no shift on "error", pop stack */
				if yyDebug >= 2 {
					__yyfmt__.Printf("error recovery pops state %d\n", yyS[yyp].yys)
				}
				yyp--
			}
			/* there is no state on the stack with an error shift ... abort */
			goto ret1

		case 3: /* no shift yet; clobber input char */
			if yyDebug >= 2 {
				__yyfmt__.Printf("error recovery discards %s\n", yyTokname(yytoken))
			}
			if yytoken == yyEofCode {
				goto ret1
			}
			yyrcvr.char = -1
			yytoken = -1
			goto yynewstate /* try again in the same state */
		}
	}

	/* reduction by production yyn */
	if yyDebug >= 2 {
		__yyfmt__.Printf("reduce %v in:\n\t%v\n", yyn, yyStatname(yystate))
	}

	yynt := yyn
	yypt := yyp
	_ = yypt // guard against "declared and not used"

	yyp -= yyR2[yyn]
	// yyp is now the index of $0. Perform the default action. Iff the
	// reduced production is ε, $1 is possibly out of range.
	if yyp+1 >= len(yyS) {
		nyys := make([]yySymType, len(yyS)*2)
		copy(nyys, yyS)
		yyS = nyys
	}
	yyVAL = yyS[yyp+1]

	/* consult goto table to find next state */
	yyn = yyR1[yyn]
	yyg := yyPgo[yyn]
	yyj := yyg + yyS[yyp].yys + 1

	if yyj >= yyLast {
		yystate = yyAct[yyg]
	} else {
		yystate = yyAct[yyj]
		if yyChk[yystate] != -yyn {
			yystate = yyAct[yyg]
		}
	}
	// dummy call; replaced with literal code
	switch yynt {

	case 1:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:219
		{
			rootnode = stmt.NewStmtList(yyDollar[1].list)
		}
	case 2:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:225
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 3:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:226
		{
			yyVAL.list = []node.Node{}
		}
	case 4:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:231
		{
			namePart := name.NewNamePart(yyDollar[1].token.Value)
			positions.AddPosition(namePart, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.list = []node.Node{namePart}
			comments.AddComments(namePart, yyDollar[1].token.Comments())
		}
	case 5:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:238
		{
			namePart := name.NewNamePart(yyDollar[3].token.Value)
			positions.AddPosition(namePart, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.list = append(yyDollar[1].list, namePart)
			comments.AddComments(namePart, yyDollar[3].token.Comments())
		}
	case 6:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:247
		{
			yyVAL.node = yyDollar[1].node
		}
	case 7:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:248
		{
			yyVAL.node = nil
		}
	case 8:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:249
		{
			yyVAL.node = nil
		}
	case 9:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:250
		{
			yyVAL.node = stmt.NewHaltCompiler()
		}
	case 10:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:252
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewNamespace(name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 11:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:262
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewNamespace(name, yyDollar[4].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[5].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 12:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:272
		{
			yyVAL.node = stmt.NewNamespace(nil, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 13:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:278
		{
			yyVAL.node = stmt.NewUseList(nil, yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 14:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:284
		{
			useType := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[2].token.Comments())

			yyVAL.node = stmt.NewUseList(useType, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 15:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:294
		{
			useType := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[2].token.Comments())

			yyVAL.node = stmt.NewUseList(useType, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 16:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:303
		{
			yyVAL.node = nil
		}
	case 17:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:307
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 18:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:308
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 19:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:313
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 20:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:323
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 21:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:336
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 22:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:346
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 23:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:362
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 24:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:366
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 25:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:373
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 26:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:383
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 27:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:396
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 28:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:406
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 29:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:422
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 30:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:426
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 31:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:433
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 32:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:443
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 33:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:456
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 34:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:466
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 35:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:481
		{
		}
	case 36:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:482
		{
		}
	case 37:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:486
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 38:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:487
		{
			yyVAL.list = []node.Node{}
		}
	case 39:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:492
		{
			yyVAL.node = yyDollar[1].node
		}
	case 40:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:493
		{
			yyVAL.node = nil
		}
	case 41:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:494
		{
		}
	case 42:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:495
		{
		}
	case 43:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:500
		{
			yyVAL.node = yyDollar[1].node
		}
	case 44:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:501
		{
		}
	case 45:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:505
		{
		}
	case 46:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:506
		{
		}
	case 47:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:506
		{
		}
	case 48:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:506
		{
		}
	case 49:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:507
		{
		}
	case 50:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:507
		{
		}
	case 51:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:507
		{
		}
	case 52:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:508
		{
		}
	case 53:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:508
		{
		}
	case 54:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:508
		{
		}
	case 55:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:509
		{
		}
	case 56:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:509
		{
		}
	case 57:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:509
		{
		}
	case 58:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:513
		{
		}
	case 59:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:515
		{
		}
	case 60:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:517
		{
		}
	case 61:
		yyDollar = yyS[yypt-12 : yypt+1]
		//line php5/php5.y:518
		{
		}
	case 62:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:519
		{
		}
	case 63:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:519
		{
		}
	case 64:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:520
		{
		}
	case 65:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:521
		{
		}
	case 66:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:522
		{
		}
	case 67:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:523
		{
		}
	case 68:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:524
		{
		}
	case 69:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:525
		{
		}
	case 70:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:526
		{
		}
	case 71:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:527
		{
		}
	case 72:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:528
		{
		}
	case 73:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:529
		{
		}
	case 74:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:530
		{
		}
	case 75:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:531
		{
		}
	case 76:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:532
		{
			yyVAL.node = yyDollar[1].node
		}
	case 77:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:533
		{
		}
	case 78:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:534
		{
		}
	case 79:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:535
		{
		}
	case 80:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:536
		{
		}
	case 81:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:536
		{
		}
	case 82:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:537
		{
		}
	case 83:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:538
		{
		}
	case 84:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:539
		{
		}
	case 85:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:540
		{
		}
	case 86:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:544
		{
		}
	case 87:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:545
		{
		}
	case 88:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:546
		{
		}
	case 89:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:547
		{
		}
	case 90:
		yyDollar = yyS[yypt-11 : yypt+1]
		//line php5/php5.y:548
		{
		}
	case 91:
		yyDollar = yyS[yypt-13 : yypt+1]
		//line php5/php5.y:549
		{
		}
	case 92:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:552
		{
		}
	case 93:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:553
		{
		}
	case 94:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:553
		{
		}
	case 95:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:557
		{
		}
	case 96:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:558
		{
		}
	case 97:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:562
		{
		}
	case 98:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:563
		{
		}
	case 99:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:567
		{
		}
	case 100:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:567
		{
		}
	case 101:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:567
		{
		}
	case 104:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:576
		{
		}
	case 105:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:580
		{
		}
	case 106:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:584
		{
		}
	case 107:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:588
		{
		}
	case 108:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:589
		{
		}
	case 109:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:593
		{
		}
	case 110:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:594
		{
		}
	case 111:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:598
		{
		}
	case 112:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:600
		{
		}
	case 113:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:605
		{
		}
	case 114:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:609
		{
		}
	case 115:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:611
		{
		}
	case 116:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:615
		{
		}
	case 117:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:620
		{
		}
	case 118:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:621
		{
		}
	case 119:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:622
		{
		}
	case 120:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:623
		{
		}
	case 121:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:627
		{
		}
	case 122:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:628
		{
		}
	case 123:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:632
		{
		}
	case 128:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:646
		{
		}
	case 129:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:647
		{
		}
	case 130:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:651
		{
		}
	case 131:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:652
		{
		}
	case 132:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:657
		{
			yyVAL.foreachVariable = foreachVariable{yyDollar[1].node, false}
		}
	case 133:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:659
		{
			yyVAL.foreachVariable = foreachVariable{yyDollar[2].node, true}
		}
	case 134:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:661
		{
			list := expr.NewList(yyDollar[3].list)
			positions.AddPosition(list, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			yyVAL.foreachVariable = foreachVariable{list, false}
			comments.AddComments(list, yyDollar[1].token.Comments())
		}
	case 141:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:688
		{
		}
	case 142:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:689
		{
		}
	case 143:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:694
		{
		}
	case 144:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:695
		{
		}
	case 145:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:696
		{
		}
	case 146:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:697
		{
		}
	case 147:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:702
		{
		}
	case 148:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:703
		{
		}
	case 149:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:703
		{
		}
	case 150:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:704
		{
		}
	case 151:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:704
		{
		}
	case 157:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:723
		{
		}
	case 158:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:723
		{
		}
	case 160:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:729
		{
		}
	case 161:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:729
		{
		}
	case 170:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:758
		{
		}
	case 171:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:760
		{
		}
	case 172:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:765
		{
		}
	case 173:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:766
		{
		}
	case 174:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:767
		{
		}
	case 175:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:768
		{
		}
	case 176:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:774
		{
			yyVAL.nodesWithEndToken = &nodesWithEndToken{[]node.Node{}, yyDollar[2].token}
		}
	case 177:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:775
		{
		}
	case 178:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:776
		{
		}
	case 181:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:786
		{
		}
	case 182:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:787
		{
		}
	case 183:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:788
		{
		}
	case 184:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:789
		{
		}
	case 185:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:793
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 186:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:794
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 187:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:800
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 188:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:810
		{
			yyVAL.node = expr.NewVariable(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 189:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:816
		{
			yyVAL.node = expr.NewVariable(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 190:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:826
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))

			staticVar := stmt.NewStaticVar(variable, nil)
			positions.AddPosition(staticVar, positionBuilder.NewTokenPosition(yyDollar[3].token))

			yyVAL.list = append(yyDollar[1].list, staticVar)

			comments.AddComments(identifier, yyDollar[3].token.Comments())
			comments.AddComments(variable, yyDollar[3].token.Comments())
			comments.AddComments(staticVar, yyDollar[3].token.Comments())
		}
	case 191:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:843
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))

			staticVar := stmt.NewStaticVar(variable, yyDollar[5].node)
			positions.AddPosition(staticVar, positionBuilder.NewTokenNodePosition(yyDollar[3].token, yyDollar[5].node))

			yyVAL.list = append(yyDollar[1].list, staticVar)

			comments.AddComments(identifier, yyDollar[3].token.Comments())
			comments.AddComments(variable, yyDollar[3].token.Comments())
			comments.AddComments(staticVar, yyDollar[3].token.Comments())
		}
	case 192:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:860
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))

			staticVar := stmt.NewStaticVar(variable, nil)
			positions.AddPosition(staticVar, positionBuilder.NewTokenPosition(yyDollar[1].token))

			yyVAL.list = []node.Node{staticVar}

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(staticVar, yyDollar[1].token.Comments())
		}
	case 193:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:877
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))

			staticVar := stmt.NewStaticVar(variable, yyDollar[3].node)
			positions.AddPosition(staticVar, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[3].node))

			yyVAL.list = []node.Node{staticVar}

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(staticVar, yyDollar[1].token.Comments())
		}
	case 196:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:904
		{
		}
	case 200:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:907
		{
		}
	case 201:
		yyDollar = yyS[yypt-9 : yypt+1]
		//line php5/php5.y:909
		{
		}
	case 203:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:917
		{
		}
	case 204:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:918
		{
		}
	case 213:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:942
		{
		}
	case 214:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:946
		{
		}
	case 215:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:947
		{
		}
	case 216:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:951
		{
		}
	case 217:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:952
		{
		}
	case 218:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:956
		{
		}
	case 219:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:960
		{
		}
	case 220:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:961
		{
		}
	case 221:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:965
		{
		}
	case 222:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:966
		{
		}
	case 223:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:970
		{
		}
	case 224:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:971
		{
		}
	case 225:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:975
		{
		}
	case 226:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:976
		{
		}
	case 227:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:980
		{
		}
	case 228:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:981
		{
		}
	case 229:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:985
		{
		}
	case 230:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:986
		{
		}
	case 231:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:990
		{
		}
	case 232:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:991
		{
		}
	case 233:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:992
		{
		}
	case 234:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:993
		{
		}
	case 235:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:994
		{
		}
	case 236:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:995
		{
		}
	case 237:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:999
		{
		}
	case 238:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1000
		{
		}
	case 239:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1001
		{
		}
	case 240:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1002
		{
		}
	case 241:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1006
		{
		}
	case 242:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1007
		{
		}
	case 243:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1011
		{
		}
	case 244:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1012
		{
		}
	case 245:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1017
		{
		}
	case 246:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1018
		{
		}
	case 247:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1022
		{
		}
	case 248:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1022
		{
		}
	case 249:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1023
		{
		}
	case 250:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1027
		{
		}
	case 251:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1028
		{
		}
	case 252:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1032
		{
		}
	case 253:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1033
		{
		}
	case 254:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1037
		{
		}
	case 255:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1037
		{
		}
	case 256:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1038
		{
		}
	case 257:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1039
		{
		}
	case 258:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1043
		{
		}
	case 259:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1044
		{
		}
	case 260:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1045
		{
		}
	case 261:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1050
		{
			if yyDollar[3].nodesWithEndToken != nil {
				yyVAL.node = expr.NewNew(yyDollar[2].node, yyDollar[3].nodesWithEndToken.nodes)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].nodesWithEndToken.endToken))
			} else {
				yyVAL.node = expr.NewNew(yyDollar[2].node, nil)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			}

			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 262:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1065
		{
			list := expr.NewList(yyDollar[3].list)
			positions.AddPosition(list, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			yyVAL.node = assign_op.NewAssign(list, yyDollar[6].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[6].node))

			comments.AddComments(list, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 263:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1074
		{
		}
	case 264:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1075
		{
		}
	case 265:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1076
		{
		}
	case 266:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:1076
		{
		}
	case 267:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1077
		{
		}
	case 268:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1078
		{
		}
	case 269:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1079
		{
		}
	case 270:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1080
		{
		}
	case 271:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1081
		{
		}
	case 272:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1082
		{
		}
	case 273:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1083
		{
		}
	case 274:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1084
		{
		}
	case 275:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1085
		{
		}
	case 276:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1086
		{
		}
	case 277:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1087
		{
		}
	case 278:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1088
		{
		}
	case 279:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1089
		{
		}
	case 280:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1090
		{
		}
	case 281:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1091
		{
		}
	case 282:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1092
		{
		}
	case 283:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1093
		{
		}
	case 284:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1094
		{
		}
	case 285:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1094
		{
		}
	case 286:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1095
		{
		}
	case 287:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1095
		{
		}
	case 288:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1096
		{
		}
	case 289:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1096
		{
		}
	case 290:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1097
		{
		}
	case 291:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1097
		{
		}
	case 292:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1098
		{
		}
	case 293:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1099
		{
		}
	case 294:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1100
		{
		}
	case 295:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1101
		{
		}
	case 296:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1102
		{
		}
	case 297:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1103
		{
		}
	case 298:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1104
		{
		}
	case 299:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1105
		{
		}
	case 300:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1106
		{
		}
	case 301:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1107
		{
		}
	case 302:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1108
		{
		}
	case 303:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1109
		{
		}
	case 304:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1110
		{
		}
	case 305:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1111
		{
		}
	case 306:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1112
		{
		}
	case 307:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1113
		{
		}
	case 308:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1114
		{
		}
	case 309:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1115
		{
		}
	case 310:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1116
		{
		}
	case 311:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1117
		{
		}
	case 312:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1118
		{
		}
	case 313:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1119
		{
		}
	case 314:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1120
		{
		}
	case 315:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1121
		{
		}
	case 316:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1122
		{
		}
	case 317:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1123
		{
		}
	case 318:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1124
		{
		}
	case 319:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1126
		{
			yyVAL.node = yyDollar[1].node
		}
	case 320:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1127
		{
		}
	case 321:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1127
		{
		}
	case 322:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1128
		{
		}
	case 323:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1129
		{
		}
	case 324:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:1130
		{
		}
	case 325:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1131
		{
		}
	case 326:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1132
		{
		}
	case 327:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1133
		{
		}
	case 328:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1134
		{
		}
	case 329:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1135
		{
		}
	case 330:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1136
		{
		}
	case 331:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1137
		{
		}
	case 332:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1138
		{
		}
	case 333:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1139
		{
		}
	case 334:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1140
		{
		}
	case 335:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1141
		{
		}
	case 336:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1142
		{
		}
	case 337:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1142
		{
		}
	case 338:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1143
		{
			yyVAL.node = yyDollar[1].node
		}
	case 339:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1144
		{
		}
	case 340:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1145
		{
		}
	case 341:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1146
		{
		}
	case 342:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1147
		{
		}
	case 343:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1148
		{
		}
	case 344:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1149
		{
		}
	case 345:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:1151
		{
		}
	case 346:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1152
		{
		}
	case 347:
		yyDollar = yyS[yypt-11 : yypt+1]
		//line php5/php5.y:1154
		{
		}
	case 348:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1158
		{
		}
	case 349:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1159
		{
		}
	case 350:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1160
		{
		}
	case 351:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1161
		{
		}
	case 352:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1165
		{
		}
	case 353:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1166
		{
		}
	case 354:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1167
		{
		}
	case 355:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1168
		{
		}
	case 356:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1172
		{
		}
	case 357:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1173
		{
		}
	case 358:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1177
		{
		}
	case 361:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1186
		{
		}
	case 362:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1187
		{
		}
	case 363:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1188
		{
		}
	case 364:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1189
		{
		}
	case 365:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1193
		{
		}
	case 366:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1194
		{
		}
	case 367:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1195
		{
		}
	case 368:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1196
		{
		}
	case 369:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1197
		{
		}
	case 370:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1198
		{
		}
	case 371:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1199
		{
		}
	case 372:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1200
		{
		}
	case 373:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1205
		{
			yyVAL.node = node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 374:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1211
		{
			yyVAL.node = name.NewName(yyDollar[1].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 375:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1217
		{
			yyVAL.node = name.NewRelative(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[3].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 376:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1223
		{
			yyVAL.node = name.NewFullyQualified(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 377:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1231
		{
		}
	case 378:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1232
		{
		}
	case 379:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1233
		{
		}
	case 380:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1238
		{
			yyVAL.node = yyDollar[1].node
		}
	case 381:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1240
		{
			yyVAL.node = yyDollar[1].node
		}
	case 382:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1245
		{
			yyVAL.node = yyDollar[1].node

			for _, f := range yyDollar[3].objectPropertyList {
				switch f.fetchType {
				case arrayFetchType:
					yyVAL.node = expr.NewArrayDimFetch(yyVAL.node, f.node)
					positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, f.node))
					comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
				case propertyFetchType:
					yyVAL.node = expr.NewPropertyFetch(yyVAL.node, f.node)
					positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, f.node))
					comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
				}
			}

			for _, f := range yyDollar[4].objectPropertyList {
				switch f.fetchType {
				case arrayFetchType:
					yyVAL.node = expr.NewArrayDimFetch(yyVAL.node, f.node)
					positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, f.node))
					comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
				case propertyFetchType:
					yyVAL.node = expr.NewPropertyFetch(yyVAL.node, f.node)
					positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, f.node))
					comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
				}
			}
		}
	case 383:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1275
		{
			yyVAL.node = yyDollar[1].node
		}
	case 384:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1281
		{
			yyVAL.objectPropertyList = append(yyDollar[1].objectPropertyList, yyDollar[2].objectPropertyList...)
		}
	case 385:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1283
		{
			yyVAL.objectPropertyList = []objectProperty{}
		}
	case 386:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1289
		{
			yyVAL.objectPropertyList = yyDollar[2].objectPropertyList
		}
	case 387:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1293
		{
		}
	case 388:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1294
		{
		}
	case 389:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1295
		{
		}
	case 390:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1299
		{
		}
	case 391:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1300
		{
		}
	case 392:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1301
		{
		}
	case 393:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1306
		{
			yyVAL.nodesWithEndToken = nil
		}
	case 394:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1308
		{
			yyVAL.nodesWithEndToken = yyDollar[1].nodesWithEndToken
		}
	case 395:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1313
		{
			yyVAL.node = scalar.NewLnumber(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 396:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1319
		{
			yyVAL.node = scalar.NewDnumber(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 397:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1325
		{
			yyVAL.node = scalar.NewString(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 398:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1331
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 399:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1337
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 400:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1343
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 401:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1349
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 402:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1355
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 403:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1361
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 404:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1367
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 405:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1373
		{
			yyVAL.node = scalar.NewString(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token)) /* TODO: mark as Heredoc*/
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 406:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1378
		{
			yyVAL.node = scalar.NewEncapsed(nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 407:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1387
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 408:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1399
		{
		}
	case 409:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1403
		{
		}
	case 410:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1404
		{
		}
	case 411:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1405
		{
		}
	case 412:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1406
		{
		}
	case 413:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1407
		{
		}
	case 414:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1408
		{
		}
	case 415:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1409
		{
		}
	case 416:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1410
		{
		}
	case 417:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1411
		{
		}
	case 418:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1412
		{
		}
	case 419:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1416
		{
		}
	case 420:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1417
		{
		}
	case 421:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1418
		{
		}
	case 422:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1419
		{
		}
	case 423:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1420
		{
		}
	case 424:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1421
		{
		}
	case 425:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1422
		{
		}
	case 426:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1423
		{
		}
	case 427:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1424
		{
		}
	case 428:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1425
		{
		}
	case 429:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1426
		{
		}
	case 430:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1427
		{
		}
	case 431:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1428
		{
		}
	case 432:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1429
		{
		}
	case 433:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1430
		{
		}
	case 434:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1431
		{
		}
	case 435:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1432
		{
		}
	case 436:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1433
		{
		}
	case 437:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1434
		{
		}
	case 438:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1435
		{
		}
	case 439:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1436
		{
		}
	case 440:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1437
		{
		}
	case 441:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1438
		{
		}
	case 442:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1439
		{
		}
	case 443:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1440
		{
		}
	case 444:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1441
		{
		}
	case 445:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1442
		{
		}
	case 446:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1443
		{
		}
	case 447:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1444
		{
		}
	case 448:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1445
		{
		}
	case 449:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1446
		{
		}
	case 450:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1447
		{
		}
	case 451:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1448
		{
		}
	case 452:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1452
		{
		}
	case 453:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1453
		{
		}
	case 454:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1454
		{
		}
	case 455:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1455
		{
		}
	case 456:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1460
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 457:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1470
		{
			yyVAL.node = yyDollar[1].node
		}
	case 458:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1472
		{
			yyVAL.node = yyDollar[1].node
		}
	case 459:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1474
		{
			yyVAL.node = yyDollar[1].node
		}
	case 460:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1476
		{
			yyVAL.node = scalar.NewEncapsed(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 461:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1482
		{
			yyVAL.node = scalar.NewEncapsed(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 462:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1488
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 463:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1496
		{
		}
	case 464:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1497
		{
		}
	case 467:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1506
		{
		}
	case 468:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1507
		{
		}
	case 469:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1508
		{
		}
	case 470:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1509
		{
		}
	case 471:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1513
		{
			yyVAL.node = yyDollar[1].node
		}
	case 472:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1514
		{
			yyVAL.node = yyDollar[1].node
		}
	case 473:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1518
		{
		}
	case 474:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1519
		{
		}
	case 475:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1525
		{
			yyVAL.node = yyDollar[1].node
		}
	case 476:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1533
		{
			yyVAL.node = yyDollar[1].node
		}
	case 477:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1540
		{
			yyVAL.node = yyDollar[1].node
		}
	case 478:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1547
		{
		}
	case 479:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1549
		{
			yyVAL.node = yyDollar[1].node
		}
	case 480:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1553
		{
		}
	case 481:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1554
		{
		}
	case 482:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1559
		{
		}
	case 483:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1559
		{
		}
	case 484:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1563
		{
		}
	case 485:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1564
		{
		}
	case 486:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1568
		{
		}
	case 487:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1569
		{
		}
	case 488:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1573
		{
		}
	case 489:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1574
		{
		}
	case 490:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1575
		{
		}
	case 491:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1580
		{
			yyVAL.node = yyDollar[1].node
		}
	case 492:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1582
		{
			yyDollar[1].simpleIndirectReference.last.SetVarName(yyDollar[2].node)

			for _, n := range yyDollar[1].simpleIndirectReference.all {
				positions[n] = positionBuilder.NewNodesPosition(n, yyDollar[2].node)
			}

			yyVAL.node = yyDollar[1].simpleIndirectReference.all[0]
		}
	case 493:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1595
		{
			yyVAL.node = expr.NewStaticPropertyFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[3].node))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 494:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1601
		{
			yyVAL.node = expr.NewStaticPropertyFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[3].node))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 495:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1611
		{
			yyVAL.node = yyDollar[1].node
		}
	case 496:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1616
		{
		}
	case 497:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1618
		{
		}
	case 498:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1622
		{
			yyVAL.node = yyDollar[1].node
		}
	case 499:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1623
		{
			yyVAL.node = yyDollar[1].node
		}
	case 500:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1624
		{
			yyVAL.node = yyDollar[1].node
		}
	case 501:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1630
		{
			yyVAL.node = yyDollar[1].node
		}
	case 502:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1632
		{
			yyDollar[1].simpleIndirectReference.last.SetVarName(yyDollar[2].node)

			for _, n := range yyDollar[1].simpleIndirectReference.all {
				positions[n] = positionBuilder.NewNodesPosition(n, yyDollar[2].node)
			}

			yyVAL.node = yyDollar[1].simpleIndirectReference.all[0]
		}
	case 503:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1642
		{
			yyVAL.node = yyDollar[1].node
		}
	case 504:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1647
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 505:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1653
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 506:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1659
		{
			yyVAL.node = yyDollar[1].node
		}
	case 507:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1665
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 508:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1675
		{
			yyVAL.node = expr.NewVariable(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 509:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1683
		{
			yyVAL.node = nil
		}
	case 510:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1684
		{
			yyVAL.node = yyDollar[1].node
		}
	case 511:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1690
		{
			yyVAL.objectPropertyList = yyDollar[1].objectPropertyList
		}
	case 512:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1692
		{
			op := objectProperty{yyDollar[1].node, propertyFetchType}
			yyVAL.objectPropertyList = []objectProperty{op}
		}
	case 513:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1700
		{
			op := objectProperty{yyDollar[3].node, arrayFetchType}
			yyVAL.objectPropertyList = append(yyDollar[1].objectPropertyList, op)
		}
	case 514:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1705
		{
			op := objectProperty{yyDollar[3].node, arrayFetchType}
			yyVAL.objectPropertyList = append(yyDollar[1].objectPropertyList, op)
		}
	case 515:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1710
		{
			op := objectProperty{yyDollar[1].node, propertyFetchType}
			yyVAL.objectPropertyList = []objectProperty{op}
		}
	case 516:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1718
		{
			yyVAL.node = node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 517:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1724
		{
			yyVAL.node = yyDollar[2].node
		}
	case 518:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1729
		{
			n := expr.NewVariable(nil)
			positions.AddPosition(n, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(n, yyDollar[1].token.Comments())

			yyVAL.simpleIndirectReference = simpleIndirectReference{[]*expr.Variable{n}, n}
		}
	case 519:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1737
		{
			n := expr.NewVariable(nil)
			positions.AddPosition(n, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(n, yyDollar[2].token.Comments())

			yyDollar[1].simpleIndirectReference.last.SetVarName(n)

			yyDollar[1].simpleIndirectReference.all = append(yyDollar[1].simpleIndirectReference.all, n)
			yyDollar[1].simpleIndirectReference.last = n
			yyVAL.simpleIndirectReference = yyDollar[1].simpleIndirectReference
		}
	case 520:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1752
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 521:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1754
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 522:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1760
		{
			yyVAL.node = yyDollar[1].node
		}
	case 523:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1762
		{
			yyVAL.node = expr.NewList(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 524:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1768
		{
			yyVAL.node = nil
		}
	case 525:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1774
		{
			yyVAL.list = nil
		}
	case 526:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1776
		{
			yyVAL.list = yyDollar[1].list
		}
	case 527:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1781
		{
			arrayItem := expr.NewArrayItem(yyDollar[3].node, yyDollar[5].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[3].node, yyDollar[5].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 528:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1789
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[3].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodePosition(yyDollar[3].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 529:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1797
		{
			arrayItem := expr.NewArrayItem(yyDollar[1].node, yyDollar[3].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[3].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 530:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1805
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[1].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodePosition(yyDollar[1].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 531:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1813
		{
			arrayItem := expr.NewArrayItem(yyDollar[3].node, yyDollar[6].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[3].node, yyDollar[6].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 532:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1821
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[4].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewTokenNodePosition(yyDollar[3].token, yyDollar[4].node))
			comments.AddComments(arrayItem, yyDollar[3].token.Comments())

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 533:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1829
		{
			arrayItem := expr.NewArrayItem(yyDollar[1].node, yyDollar[4].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[4].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 534:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1837
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[2].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(arrayItem, yyDollar[1].token.Comments())

			yyVAL.list = []node.Node{arrayItem}
		}
	case 535:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1848
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 536:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1850
		{
			encapsed := scalar.NewEncapsedStringPart(yyDollar[2].token.Value)
			positions.AddPosition(encapsed, positionBuilder.NewTokenPosition(yyDollar[2].token))
			yyVAL.list = append(yyDollar[1].list, encapsed)
			comments.AddComments(encapsed, yyDollar[2].token.Comments())
		}
	case 537:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1857
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 538:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1859
		{
			encapsed := scalar.NewEncapsedStringPart(yyDollar[1].token.Value)
			positions.AddPosition(encapsed, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.list = []node.Node{encapsed, yyDollar[2].node}
			comments.AddComments(encapsed, yyDollar[1].token.Comments())
		}
	case 539:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1869
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 540:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1879
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewArrayDimFetch(variable, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 541:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1892
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))
			fetch := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(fetch, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewPropertyFetch(variable, fetch)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(fetch, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 542:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1908
		{
			yyVAL.node = expr.NewVariable(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 543:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1914
		{
			identifier := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[2].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[2].token))
			yyVAL.node = expr.NewArrayDimFetch(variable, yyDollar[4].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[6].token))

			comments.AddComments(identifier, yyDollar[2].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 544:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1928
		{
			yyVAL.node = yyDollar[2].node
		}
	case 545:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1933
		{
			yyVAL.node = scalar.NewString(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 546:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1939
		{
			// TODO: add option to handle 64 bit integer
			if _, err := strconv.Atoi(yyDollar[1].token.Value); err == nil {
				yyVAL.node = scalar.NewLnumber(yyDollar[1].token.Value)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			} else {
				yyVAL.node = scalar.NewString(yyDollar[1].token.Value)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			}
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 547:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1951
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(identifier)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 548:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1964
		{
			yyVAL.node = expr.NewIsset(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 549:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1970
		{
			yyVAL.node = expr.NewEmpty(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 550:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1976
		{
			yyVAL.node = expr.NewEmpty(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 551:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1982
		{
			yyVAL.node = expr.NewInclude(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 552:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1988
		{
			yyVAL.node = expr.NewIncludeOnce(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 553:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1994
		{
			yyVAL.node = expr.NewEval(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 554:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2000
		{
			yyVAL.node = expr.NewRequire(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 555:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2006
		{
			yyVAL.node = expr.NewRequireOnce(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 556:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2015
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 557:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2017
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 558:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2021
		{
			yyVAL.node = yyDollar[1].node
		}
	case 559:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2022
		{
			yyVAL.node = yyDollar[1].node
		}
	case 560:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2027
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 561:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2037
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 562:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2050
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 563:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2063
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	}
	goto yystack /* stack new state and value */
}
